
#include "Header/GLsetups.h"

//NEHE RAW LOADING

// Loads The .RAW File And Stores It In pHeightMap
void LoadRawFile(LPSTR strName, int nSize, BYTE *pHeightMap)
{
	FILE *pFile = NULL;

	// Open The File In Read / Binary Mode.
	pFile = fopen( strName, "rb" );

	// Check To See If We Found The File And Could Open It
	if ( pFile == NULL )	
	{
		// Display Error Message And Stop The Function
		MessageBox(NULL, "Can't Find RAW file!", "Error", MB_OK);
		return;
	}

	// Here We Load The .RAW File Into Our pHeightMap Data Array
	// We Are Only Reading In '1', And The Size Is (Width * Height)
	fread( pHeightMap, 1, nSize, pFile );

	// After We Read The Data, It's A Good Idea To Check If Everything Read Fine
	int result = ferror( pFile );

	// Check If We Received An Error
	if (result)
	{
		MessageBox(NULL, "Failed To Get Data!", "Error", MB_OK);
	}

	// Close The File
	fclose(pFile);
}



void initLight (void)
{
	static float fsAmb[]= {0.25, 0.25, 0.25, 1};
	float l0Dir[]= {0, 10, 0, 1};

	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	
	glMaterialf(GL_FRONT, GL_SHININESS, 0.0);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);

	//glLightModelfv(GL_LIGHT_MODEL_AMBIENT, (GLfloat*)&fsAmb);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);

	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_POSITION, l0Dir);
} // initLight

void help (void)
{/*
	printf("Controls:-\n"); 
	printf("\tLeft mouse drag - set orientation (theta, phi)\n"); 
	printf("\tRight mouse drag - set depth\n");
	printf("\tB - add Blobs (particle accretion)\n");
	printf("\tF - apply geological Faulting\n");
	printf("\tH - Help (show this message)\n");
	printf("\tN - add white Noise\n");
	printf("\tR - Reset\n");
	printf("\tS - Smooth (apply low pass filter)\n");
	printf("\tESC - Exit\n");*/
} // help



void endFrame (void)
{
	// Swap frame buffers over (makes what we've drawn become visible on screen)
    glutSwapBuffers();
	// Signal that we want the scene redrawn as soon as possible
    glutPostRedisplay();
} // endFrame


void OrthoMode(int left, int top, int right, int bottom) //####################### NOT MY CODE ############
{

	glMatrixMode(GL_PROJECTION);			// Select Projection
	glPushMatrix();							// Push The Matrix
	glLoadIdentity();						// Reset The Matrix
	glOrtho( left, right, bottom, top, 0, 1 );	// Select Ortho Mode (640x480)
	glMatrixMode(GL_MODELVIEW);				// Select Modelview Matrix
	glPushMatrix();							// Push The Matrix
	glLoadIdentity();
}

void PerspectiveMode()										// Set Up A Perspective View
{
	glMatrixMode( GL_PROJECTION );
	glPopMatrix();
	glMatrixMode( GL_MODELVIEW );							
	glPopMatrix();
}