#ifndef _2DWATER_H_
#define _2DWATER_H_

#include "terrain.h"
#include "Header/GLsetups.h"

#define WATER_WIDTH	(128)
#define WATER_DEPTH	(128)

#define TEXTURED		(1<<0)
#define	NORMALS			(1<<1)
#define	SMOOTH			(1<<2)
#define	REFRACT_ME		(1<<3)
#define	REFRACT_TERRAIN	(1<<4)


typedef struct{

	int	val[WATER_WIDTH][WATER_DEPTH];

}buffer;


class water2d
{
	buffer a;
	buffer b;
	buffer smooth;
	Vec3F normal[WATER_WIDTH][WATER_DEPTH];
	float	damping,
			scalexz,
			scaley;
	
public:

	float level;	
	water2d();
	void AddDrop(int x, int z);
	void Update ();
	void smoothout();
	float heightAtSmoothPoint(float tx, float ty);

	void Draw (float scale);
	void Draw3D(float alpha);
	void Draw3DWithNormals(float alpha);
	void Draw3DTextured(float alpha, float texscale);
	void Draw3DTexturedSmoothRefracted(float alpha, float texscale, bool under);
	void Draw3DTexturedSmoothIce(float alpha, float texscale);
	
	void Draw3DSmoothRefractedTerrain(float alpha, float texscale, terrain &thisTerrain);
	//void terr(terrain &x);
};


#endif
