/*** CONSTANTS ***/

// Initial window/viewport dimensions (in pixels)
#define WIN_WIDTH	(705)
#define WIN_HEIGHT	(512)

// Initial frustum dimensions (in geometric space)
#define FR_WIDTH	((float)0.125*1.3333333333333333333333333333333f)
#define FR_HEIGHT	((float)0.125)
#define FR_NEAR		((float)0.25)
#define FR_FAR		((float)3000)

// Mouse buttons
#define MB_LEFT		(1<<2)
#define MB_MID		(1<<1)
#define MB_RIGHT_	(1<<0)

// Non-printable keys
#define KEY_ESC			(27)
#define MY_LEFT			(12)
#define MY_RIGHT		(13)
#define MY_UP			(14)
#define MY_DOWN			(15)

#define NOISE_HEIGHT	(1.0)
#define FAULT_HEIGHT	(4.0)
#define BLOB_RADIUS		(8.0)
#define BLOB_HEIGHT		(2.0)

#define MODE_1STPERSON		(1<<0)
#define MODE_WIRE			(1<<1)
#define MODE_WATER			(1<<2)
#define MODE_ENV			(1<<3)
#define MODE_UPDATE_PLAYER	(1<<4)
#define MODE_TRACK			(1<<5)
#define MODE_CLOUDS			(1<<6)
#define MODE_ANAGLYPH		(1<<7)
#define MODE_CROSSEYED		(1<<8)
#define MODE_GAME			(1<<9)
#define MODE_PARTICLES		(1<<10)
#define MODE_TREES			(1<<11)
#define MODE_FISH			(1<<12)
#define MODE_BOIDS			(1<<13)



#define PI	((float)3.141592654)

#define RANDOM		(1)
#define MOUNTAIN	(1)


#define TERR_WIDTH	(128)
#define TERR_DEPTH	(128)

#define NUMTEXTURES	  15

#define MODE_FLAT			(0)
#define MODE_TEXTURE_FULL	(1)
#define MODE_TEXTURE_REPEAT	(2)
#define MODE_TEXTURE_ARB	(3)
#define MODE_TEXTURE_MULTI	(4)

#define NUM_ENEMIES			(20)
#define NUM_TREES			(50)
#define NUM_FISH			(100)
#define NUM_BOIDS			(10)
/*

1000 0000
1000 0000 &

1000 0000


1000 0000
0111 1111 &

0000 0000

0000 0000
0111 1111 &

1000 0000











  */