#ifndef _ENEMY_H_
#define _ENEMY_H_

#include "defines.h"
#include "vectorclass.h"
#include "particles.h"
#include "glut.h"
#include "weapons.h"


class enemy{
	float	speed;
	float	friction;

public:
	Vec3F	position,
			velocity,
			rotation;
	Col3F	colour;
	float	radius;
	float	size;
	float	energy;
	int		active;

	enemy();
	void reset();
	void moveInCircle(float amount, float radius);
	void moveTowards(Vec3F &tome, float speed);
	void moveParalell(Vec3F &tome, float speed);
	void moveRandom(float speed);
	void AdjustVelocity(float x, float y, float z);
	void Update(environment &localWorld);
	void draw(float scale);
	void drawExplode(float scale);
	void setHeight(float y);

};

class agressorEnemy{
	int willIShoot;
public:
	enemy base;
	projectileWeapon gun;

	agressorEnemy();
	reset();
	shoot(Vec3F &at);
	draw(float scale);
};


#endif