#ifndef _PARTICLES_H
#define _PARTICLES_H

#include "Header/vectorclass.h"
#include "defines.h"
#include "glut.h"

typedef struct{
	float	viscosity;
	Vec3F	gravity;
			
}environment;


class particle
{

public:	
	
	Vec3F	position,
			velocity,
			oldpos;	
	float	mass, 
			elasticity,
			birthage,
			age, 
			decayrate,
			scale;
			;
	int		alive;
	GLuint	texture;
	Col4F	colour;


	particle();
	void update(environment iamhere, float groundheight, float groundbounce);
	void updatePosition();
	void decay();
	void gravitate(environment thisworld);
	void collideGroundPlane(float height, float bounce);
	void environmentResist(environment thisworld);
	void drawFlatQuad(float theta, float phi);
	void drawTexturedQuad(float theta, float phi);
	void drawLine(float length, float theta, float phi);

};


/*
typedef struct{
	float	x,y,z,
			radius, strength
			;
}attractor;

void ParticleInit(particle *initme);
void ParticleEmmit(particle *initme, emmiter *fromhere);
void ParticleUpdate(particle *updateme);
void ParticleGravity(particle *updateme, float x, float y, float z);
void ParticleGroundCollision(particle *updateme, float HeightOfGround, float Bounce);
void ParticleAirResistance(particle *updateme, float AirResistance);
void ParticleDisplace(particle *pushme, projectile *pusher, float closest, float furthest, float numerator );
void ParticleDraw(particle *drawme, float scale, float theta, float phi);


void ParticleDrawLine(particle *drawme, float scale, float length);
void ParticleAttract(particle *pullme, attractor *tohere);
void ParticleAttractorDraw(attractor *drawme);
*/

#endif