#ifndef _PLANT_H
#define _PLANT_H

/*
	Copyright A N Houston, University of Abertay Dundee, Sept 2001.

	$Id$

*/

#include "glut.h"
#include "Header/vector.h"


#ifdef __cplusplus
extern "C" {
#endif

/*** COMPILATION DIRECTIVES ***/


/*** CONSTANTS ***/



/*** TYPES ***/

typedef struct 
{
	float min, max;
} MinMaxF, *MinMaxFPtr;

typedef struct 
{
	uint min, max;
} MinMaxU, *MinMaxUPtr;

typedef struct
{
	MinMaxU	branches;
	MinMaxF	limbLength;
	MinMaxF	branchLength;
	MinMaxF	theta;
} Limb, *LimbPtr;

typedef struct
{
	Limb	limbs;
	MinMaxU	levels;
	MinMaxF	scale;
} Plant, *PlantPtr;

/*** MACROS ***/


/*** GLOBALS ***/


/*** FUNCTIONS ***/

extern void plantDraw (PlantPtr pPL);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _PLANT_H
