#ifndef _TERR_H
#define _TERR_H

/*
	Copyright A N Houston, University of Abertay Dundee, Sept 2001.

	$Id$

*/

#include "glut.h"
#include "Header/vector.h"


#ifdef __cplusplus
extern "C" {
#endif

/*** COMPILATION DIRECTIVES ***/


/*** CONSTANTS ***/


/*** TYPES ***/

typedef float Sample, *SamplePtr;

typedef struct
{
	Sample	s[TERR_WIDTH][TERR_DEPTH];
} HeightField, *HeightFieldPtr;

typedef struct
{
	HeightField	h;
	Vector		n[TERR_WIDTH][TERR_DEPTH];
} TerrainBlock, *TerrainBlockPtr;


typedef struct
{
	Vector	n;
	float	s;
} Plane, *PlanePtr;
/*
typedef struct
{
	float r, g, b;
} Col3F;
*/

/*** MACROS ***/


/*** GLOBALS ***/


/*** FUNCTIONS ***/

extern void terrReset (TerrainBlockPtr pTB);

extern void terrSmooth (TerrainBlockPtr pTB);

extern void terrAddNoise (TerrainBlockPtr pTB, float m);

extern void terrAddBlobs (TerrainBlockPtr pTB, float r, float h, uint n);

extern void terrGenFaults (TerrainBlockPtr pTB, float dh, uint n);

extern void terrDraw (TerrainBlockPtr pTB);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _TERR_H
