#ifndef _TERRAIN_H
#define _TERRAIN_H

#include "glut.h"
#include <stdio.h>
#include "Header/vectorclass.h"
#include "Header/glext.h"
//#include "Header/main.h"
#include "Header/globals.h"

//#define TERR_WIDTH	(64)
//#define TERR_DEPTH	(64)


typedef unsigned char byte;
typedef float Sample;

typedef struct
{
	Sample	height[TERR_WIDTH][TERR_DEPTH];
} HeightField;

class plane
{
public:
	Vec3F	norm;
	float	s;

	void randomise (Vec3F &vect);
	float pointSeperation (Vec3F &thispoint);

};



class terrain
{
	Vec3F	normal[TERR_WIDTH][TERR_DEPTH];

public:
	bool	thinking;
	float	scale;
	float texscale;
	GLuint	displayListTerr;
	HeightField	elevation;
	HeightField	PlannedElevation;
	HeightField	normal_elevation;

	terrain();
	void Reset ();
	void Set (float h);
	void Update (float h);
	void UpdateWipe(float h);
	void randomPoint(Vec3F &temp);
	void Smooth ();
	void AddNoise (float m);
	void GenFaults (float dh, uint n);
	void Draw (int mode, float arb);
	void DrawNormals ();
	void CalcNormals();
	void Wave();
	void AddBlob (float r, float h);
	void AddBlobAt (float ax, float az, float r, float h);
	void ScaleHeightMap(float magnitude);
	void ApplyFaultPlane (plane &pP, float dh);
	float normaliseHeight(float theight, bool h);
	void makeFromHeightMap(byte *hmap, float scale, bool add);
	void makeFromHeightMapI(int hmap[][128], float scale, bool add);

	float heightAtPoint(float tx, float ty);
	Vec3F DownHillVectorForPoint(float tx, float ty);
	int isOnTerrain(float x, float z);

	void GenDisplayList ();
	void drawDisplayList();


};



class fence
{

	GLuint	displayList;
//	Vec3F	start, end;
//	float	height;
//	float	segments;

//	fence();
	public:
void fence::newfence(Vec3F from, Vec3F to, int segments, float height, terrain &onme);
	void draw();

};
#endif
