#ifndef _WEAPONS_H_
#define _WEAPONS_H_

#include "Header/vectorclass.h"
#include "glut.h"
#include "stdio.h"
#include "terrain.h"
#include "collision.h"

#define NUMPROJECTILES		(200)

class projectile{

	Vec3F velocity;
	float radius;
	int active;

public:
	Vec3F position;

	projectile();
	void reset();
	void launch(Vec3F &from, Vec3F &to, float speed);
	void update();
	void setHeight(float h);
	int collideSphere(Vec3F target, float radius);
	void draw(float scale);

};

class projectileWeapon{

	public:
		projectile bullet[NUMPROJECTILES];
		int round;

		projectileWeapon();
		void reset();
		void fire(Vec3F &from, Vec3F &to, float speed);
		void update(terrain &thisterrain);
		void draw(float scale);


};



#endif