//======================================================================================
// main.cpp  |  terrain demo  |  ca321 (yr2003)
//--------------------------------------------------------------------------------------
//
//
//
//======================================================================================

#pragma comment( lib, "source/glut32.lib" )	//include glut library when compiling

#include "Header/main.h"


/*** GLOBALS ***/

Viewport gVP=
{
	{0, 0},
	{WIN_WIDTH, WIN_HEIGHT}
};

Frustum	gFR=
{
	-0.5*FR_WIDTH, 0.5*FR_WIDTH,
		-0.5*FR_HEIGHT, 0.5*FR_HEIGHT,
		FR_NEAR, FR_FAR,
		1.0f
};

Mouse gMouse=
{
	{0,0},
	0,0
};

typedef	struct										// Create A Structure
{
	GLubyte	*imageData;								// Image Data (Up To 32 Bits)
	GLuint	bpp;									// Image Color Depth In Bits Per Pixel
	GLuint	width;									// Image Width
	GLuint	height;									// Image Height
	GLuint	texID;									// Texture ID Used To Select A Texture
} TextureImage;		

#define RENDEREDTEXTURESIZE		512

// Multitexture functions.
PFNGLACTIVETEXTUREARBPROC           glActiveTextureARB = 0;
PFNGLCLIENTACTIVETEXTUREARBPROC     glClientActiveTextureARB = 0;
PFNGLMULTITEXCOORD2FARBPROC			glMultiTexCoord2fARB = 0;

void game_loop();
void mouse_menu_input(Mouse &tmouse, Viewport &vp, float scale);
void renderAnaglyph(float seperation, float theta, float phi);
void renderCrossEyed(float seperation, float theta, float phi);

GLuint	texturelist[NUMTEXTURES];			// Storage For Textures
GLuint	RenderedTexture;					// An Unsigned Int To Store The Texture Number
GLuint	RenderedTexture2;					// An Unsigned Int To Store The Texture Number
TextureImage tiTree;
float wateralpha = 0.90f;
terrain TheTerrain;
BYTE rawHeightMap[TERR_WIDTH*TERR_DEPTH];	// HeightMap for terrain
uint upordown = 0;

water2d TheWater;
uint modes= 0;
uint style3d = 0;
uint nrm = -1;
Vec3F light0 = {0,0,0};
float l0Dir[]= {-128, 128, 128, 1};
float texscale = 1.0f;
int texmode = 4;
int cammode = 0;
int rendermode = 0;
int perlin[128][128];
bool keys[256];
Vec2I guiPos = {0,0};
Vec2I guiSize = {1.0f,1.0f};

aabb aabbPlayer, box;

player ThePlayer;
enemy TheEnemy[NUM_ENEMIES];
agressorEnemy TheAgressor;


projectile TheProjectile;
projectileWeapon TheProjectileWeapon;
camera TheCamera;
emmiter emmit1;
environment air;
environment water;
skybox TheSky;
fence TheFence[1];

tree TheTree[NUM_TREES];
fish TheFish[NUM_FISH];
boid TheBoid[NUM_BOIDS];

void renderScene(float theta, float phi);
void renderSceneWobbly(float theta, float phi, float r, float magnitude);

//######################################################################################################
//NEHE texture loading stuff ------------------------------------------------------------------------- NEHE texture loading stuff 

GLuint EmptyTexture(int sizex, int sizey)											// Create An Empty Texture
{
	GLuint txtnumber;											// Texture ID
	unsigned int* data;											// Stored Data
	
	// Create Storage Space For Texture Data (128x128x4)
	data = (unsigned int*)new GLuint[((sizex * sizey)* 4 * sizeof(unsigned int))];
	ZeroMemory(data,((sizex * sizey)* 4 * sizeof(unsigned int)));	// Clear Storage Memory
	
	glGenTextures(1, &txtnumber);								// Create 1 Texture
	glBindTexture(GL_TEXTURE_2D, txtnumber);					// Bind The Texture
	glTexImage2D(GL_TEXTURE_2D, 0, 4, sizex, sizey, 0,
		GL_RGBA, GL_UNSIGNED_BYTE, data);						// Build Texture Using Information In data
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	
	delete [] data;												// Release data
	
	return txtnumber;											// Return The Texture ID
}



AUX_RGBImageRec *LoadBMP(char *Filename)				// Loads A Bitmap Image
{
	FILE *File=NULL;									// File Handle
	
	if (!Filename)										// Make Sure A Filename Was Given
	{
		return NULL;									// If Not Return NULL
	}
	
	File=fopen(Filename,"r");							// Check To See If The File Exists
	
	if (File)											// Does The File Exist?
	{
		fclose(File);									// Close The Handle
		return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
	}
	
	return NULL;										// If Load Failed Return NULL
}


int LoadGLTexture(char *thistex, int texspace)									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator
	
	AUX_RGBImageRec *TextureImage[1];					// Create Storage Space For The Texture
	
	memset(TextureImage,0,sizeof(void *)*1);           	// Set The Pointer To NULL
	
	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if (TextureImage[0]=LoadBMP(thistex))
	{
		Status=TRUE;									// Set The Status To TRUE
		
		glGenTextures(1, &texturelist[texspace]);					// Create The Texture
		
		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, texturelist[texspace]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		
		// Create MipMapped Textures
		glBindTexture(GL_TEXTURE_2D, texturelist[texspace]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST); // ( NEW )
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 
			GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data); // ( NEW )
		
		
		
		
	}
	
	if (TextureImage[0])									// If Texture Exists
	{
		if (TextureImage[0]->data)							// If Texture Image Exists
		{
			free(TextureImage[0]->data);					// Free The Texture Image Memory
		}
		
		free(TextureImage[0]);								// Free The Image Structure
	}
	
	return Status;										// Return The Status
}


bool LoadTGA(TextureImage *texture, char *filename)			// Loads A TGA File Into Memory
{    
	GLubyte		TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0};	// Uncompressed TGA Header
	GLubyte		TGAcompare[12];								// Used To Compare TGA Header
	GLubyte		header[6];									// First 6 Useful Bytes From The Header
	GLuint		bytesPerPixel;								// Holds Number Of Bytes Per Pixel Used In The TGA File
	GLuint		imageSize;									// Used To Store The Image Size When Setting Aside Ram
	GLuint		temp;										// Temporary Variable
	GLuint		type=GL_RGBA;								// Set The Default GL Mode To RBGA (32 BPP)

	FILE *file = fopen(filename, "rb");						// Open The TGA File

	if(	file==NULL ||										// Does File Even Exist?
		fread(TGAcompare,1,sizeof(TGAcompare),file)!=sizeof(TGAcompare) ||	// Are There 12 Bytes To Read?
		memcmp(TGAheader,TGAcompare,sizeof(TGAheader))!=0				||	// Does The Header Match What We Want?
		fread(header,1,sizeof(header),file)!=sizeof(header))				// If So Read Next 6 Header Bytes
	{
		if (file == NULL)									// Did The File Even Exist? *Added Jim Strong*
			return false;									// Return False
		else
		{
			fclose(file);									// If Anything Failed, Close The File
			return false;									// Return False
		}
	}

	texture->width  = header[1] * 256 + header[0];			// Determine The TGA Width	(highbyte*256+lowbyte)
	texture->height = header[3] * 256 + header[2];			// Determine The TGA Height	(highbyte*256+lowbyte)
    
 	if(	texture->width	<=0	||								// Is The Width Less Than Or Equal To Zero
		texture->height	<=0	||								// Is The Height Less Than Or Equal To Zero
		(header[4]!=24 && header[4]!=32))					// Is The TGA 24 or 32 Bit?
	{
		fclose(file);										// If Anything Failed, Close The File
		return false;										// Return False
	}

	texture->bpp	= header[4];							// Grab The TGA's Bits Per Pixel (24 or 32)
	bytesPerPixel	= texture->bpp/8;						// Divide By 8 To Get The Bytes Per Pixel
	imageSize		= texture->width*texture->height*bytesPerPixel;	// Calculate The Memory Required For The TGA Data

	texture->imageData=(GLubyte *)malloc(imageSize);		// Reserve Memory To Hold The TGA Data

	if(	texture->imageData==NULL ||							// Does The Storage Memory Exist?
		fread(texture->imageData, 1, imageSize, file)!=imageSize)	// Does The Image Size Match The Memory Reserved?
	{
		if(texture->imageData!=NULL)						// Was Image Data Loaded
			free(texture->imageData);						// If So, Release The Image Data

		fclose(file);										// Close The File
		return false;										// Return False
	}

	for(GLuint i=0; i<int(imageSize); i+=bytesPerPixel)		// Loop Through The Image Data
	{														// Swaps The 1st And 3rd Bytes ('R'ed and 'B'lue)
		temp=texture->imageData[i];							// Temporarily Store The Value At Image Data 'i'
		texture->imageData[i] = texture->imageData[i + 2];	// Set The 1st Byte To The Value Of The 3rd Byte
		texture->imageData[i + 2] = temp;					// Set The 3rd Byte To The Value In 'temp' (1st Byte Value)
	}

	fclose (file);											// Close The File

	// Build A Texture From The Data
	glGenTextures(1, &texture[0].texID);					// Generate OpenGL texture IDs

	glBindTexture(GL_TEXTURE_2D, texture[0].texID);			// Bind Our Texture
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);	// Linear Filtered
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	// Linear Filtered
	
	if (texture[0].bpp==24)									// Was The TGA 24 Bits
	{
		type=GL_RGB;										// If So Set The 'type' To GL_RGB
	}

	glTexImage2D(GL_TEXTURE_2D, 0, type, texture[0].width, texture[0].height, 0, type, GL_UNSIGNED_BYTE, texture[0].imageData);

	return true;											// Texture Building Went Ok, Return True
}



void RenderToTexture(int sizex, int sizey, float theta, float phi, GLuint thisTex)											// Renders To A Texture
{
	glViewport(0,0,sizex,sizey);									// Set Our Viewport (Match Texture Size)
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);	//  background
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);			// Clear The Screen And Depth Buffer
	
	//render these things
	

	renderScene(theta, phi);
	//end render
	
	glBindTexture(GL_TEXTURE_2D,thisTex);					// Bind To The Blur Texture
	
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE, 0, 0, sizex, sizey, 0);
	
	glClearColor(0.25f, 0.25f, 0.25f, 1.0f);	//  background
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);			// Clear The Screen And Depth Buffer
	
	glViewport(gVP.origin.x , gVP.origin.y, gVP.size.x ,gVP.size.y);									// Set Viewport (0,0 to 640x480)
}

void RenderLightmap(int size, float viewx, float viewy, float phi, float theta, float depth)											// Renders To A Texture
{
	glViewport(0,0,size,size);									// Set Our Viewport (Match Texture Size)
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);	//  background
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);			// Clear The Screen And Depth Buffer
	
		glTranslatef(0, 0, -depth);
		//glRotatef(theta, 0,1,0);
		glRotatef(90, 1,0,0);
//	OrthoMode(0, 0, WIN_WIDTH, WIN_HEIGHT);

	//render these things	
	glLightfv(GL_LIGHT0, GL_POSITION, l0Dir);

	TheTerrain.Draw(MODE_FLAT, 1.0f);
	//end render
	
	glBindTexture(GL_TEXTURE_2D,RenderedTexture);					// Bind To The Blur Texture
	
	// Copy Our ViewPort To The Blur Texture (From 0,0 To 128,128... No Border)
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE, 0, 0, size, size, 0);
	
	glClearColor(0.8f, 0.8f, 1.0f, 1.0f);	//  background
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);			// Clear The Screen And Depth Buffer
	PerspectiveMode();	
	glViewport(0 , 0,viewx ,viewy);									// Set Viewport (0,0 to 640x480)
}


// Set basic OpenGL states
void init (void)
{
	// Have a look at what we're running on (just curious)
	printf("%s\n", (char*)glGetString(GL_VENDOR)); 
	printf("%s\n", (char*)glGetString(GL_RENDERER)); 
	printf("Open GL v%s\n\n", (char*)glGetString(GL_VERSION));
	//printf("%s\n", (char*)glGetString(GL_EXTENSIONS));
	
	// Set miscellaneous modes
	glClearColor(0.8f, 0.8f, 1.0f, 1.0f);	//  background
	
	glEnable(GL_DEPTH_TEST);
	glPolygonMode( GL_FRONT, GL_FILL );					// Front Face Is Solid
	glPolygonMode( GL_BACK, GL_LINE );					// Back Face Is Made Of Lines
	
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	
	initLight();
	
	//textures
	printf("bmp:\n%d",LoadGLTexture("textures\\sun.bmp", 0));
	printf("%d",LoadGLTexture("textures\\gui.bmp", 1));
	printf("%d",LoadGLTexture("textures\\grass2.bmp", 2));
	printf("%d",LoadGLTexture("textures\\heighttexture.bmp", 3));
	printf("%d",LoadGLTexture("textures\\water2.bmp", 4));
	printf("%d",LoadGLTexture("textures\\rock.bmp", 5));
	//skybox textures
	printf("%d",LoadGLTexture("textures/skyboxF.bmp", 6));
	printf("%d",LoadGLTexture("textures/skyboxBK.bmp",7));
	printf("%d",LoadGLTexture("textures/skyboxL.bmp", 8));
	printf("%d",LoadGLTexture("textures/skyboxR.bmp", 9));
	printf("%d",LoadGLTexture("textures/skyboxT.bmp", 10));
	printf("%d",LoadGLTexture("textures/skyboxB.bmp", 11));

	printf("%d",LoadGLTexture("textures/tree.bmp", 12));
	printf("%d",LoadGLTexture("textures/treemask.bmp", 13));
	
	printf("\n\ntga:\n%d",LoadTGA(&tiTree,"textures/tree.TGA"));
	LoadRawFile("textures/heightmap.raw", TERR_WIDTH*TERR_DEPTH, rawHeightMap);	// ( NEW )
	
	RenderedTexture = EmptyTexture(RENDEREDTEXTURESIZE,RENDEREDTEXTURESIZE);		
	RenderedTexture2 = EmptyTexture(RENDEREDTEXTURESIZE,RENDEREDTEXTURESIZE);							// Create Our Empty Texture
	
	glShadeModel(GL_SMOOTH);						// Enable Smooth Shading
	glEnable(GL_DEPTH_TEST);						// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);							// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);			// Really Nice Perspective Calculations
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glClearDepth(1.0f);								// Depth Buffer Setup
	
	//environment mapping stuff
	glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	
	// Multi texture functions
	glActiveTextureARB		 =	(PFNGLACTIVETEXTUREARBPROC)wglGetProcAddress("glActiveTextureARB");
	glClientActiveTextureARB =	(PFNGLCLIENTACTIVETEXTUREARBPROC)wglGetProcAddress("glClientActiveTextureARB");
	glMultiTexCoord2fARB	 =	(PFNGLMULTITEXCOORD2FARBPROC)wglGetProcAddress("glMultiTexCoord2fARB");
	
	
	for(int i = 0; i<256; i++)
		keys[i] = 0;
	
	TheTerrain.Reset();
	perlin128(perlin);

	TheCamera.SetCamera(0.0f, 2.0f, 10.0f, 
		0.0f, 2.0f, 0.0f, 
		0.0f, 1.0f, 0.0f);
	//	help();
	emmiter_setup(&emmit1);
	air.gravity.x		= 0;
	air.gravity.y		= -0.01f;
	air.gravity.z		= 0;
	air.viscosity		= 1.0f;
	
	water.gravity.x		= 0;
	water.gravity.y		= 0.00f;
	water.gravity.z		= 0;
	water.viscosity		= 0.9f;
	
	for(int n = 0; n<NUM_ENEMIES; n++)	
	{
		TheEnemy[n].position.x = (-TERR_WIDTH*2) + rand()%128*4;
		TheEnemy[n].position.z = (-TERR_DEPTH*2) + rand()%128*4;
		
	}

	for( n = 0; n<NUM_TREES; n++)	
	{
		TheTree[n].random(TERR_WIDTH*2.0f, TERR_DEPTH*2.0f, TheTerrain);
		
	}
	for( n = 0; n<NUM_FISH; n++)	
	{
		TheFish[n].init(n,n,n);		
	}

	for( n = 0; n<NUM_BOIDS; n++)	
	{
		TheBoid[n].init(5*sin(n),3*cos(n),5*cos(n));
		
	}

	perlin128(perlin);
	TheTerrain.makeFromHeightMapI(perlin, 0.1f, 0);
	TheTerrain.normaliseHeight(10.0f, 1);
	TheTerrain.Reset();

	box.halfSize.x = 20.0f;
	box.halfSize.y = 40.0f;
	box.halfSize.z = 20.0f;

	box.position.x = 30.0f;
	box.position.y = 40.0f;
	box.position.z = 30.0f;

	aabbPlayer.halfSize.x = 1.0f;
	aabbPlayer.halfSize.y = 1.0f;
	aabbPlayer.halfSize.z = 1.0f;

	aabbPlayer.position.x = 0.0f;
	aabbPlayer.position.y = 1.0f;
	aabbPlayer.position.z = 0.0f;

	thelp();

//glutFullScreen( ); 
} // init

void startFrame (void)
{
	// Clear the colour and depth buffers
    glClear(GL_DEPTH_BUFFER_BIT);
	
	// Define the viewport within the window (usually full size)
	glViewport(gVP.origin.x, gVP.origin.y, gVP.size.x, gVP.size.y);
	
	// Now we set up a perspective projection so that the 3D world becomes
	// visible as a 2D image within the viewport.
	// **Following operations are applied to the projection matrix stack**
	glMatrixMode(GL_PROJECTION);	
	// Load the identity matrix (further transformations will be multiplied with this)
	glLoadIdentity();				
	// Define a perspective view volume - this creates a projection matrix
	// and multiples it onto the top of the projection matrix stack
    glFrustum(gFR.left, gFR.right, gFR.bottom, gFR.top, gFR.zNear, gFR.zFar);	
	
	// **Following operations are applied to the modelling/viewing matrix stack**
	glMatrixMode(GL_MODELVIEW);
	// Load the identity matrix (further transformations will be multiplied with this)
	glLoadIdentity();
} // startFrame

void renderScene(float theta, float phi)
{

	
	TheSky.draw(500.0f, texturelist);
	
	
	
	/*
	glLineWidth(5.0);
	glColor3f(0,0,0);
	GlutOutputText3D(-100, 0, 0,0.2f, "Some text");
	glLineWidth(1.0);
	*/
	
	glColor3f(0.5, 1, 0.25);	
	glLightfv(GL_LIGHT0, GL_POSITION, l0Dir);
	
	
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, texturelist[2]);
	
	if (modes & MODE_WIRE)
	{
		glPolygonMode( GL_FRONT, GL_LINE );
	}
	else
	{
		glPolygonMode( GL_FRONT, GL_FILL );
	}
	
	if (modes & MODE_ENV)
	{
		glEnable(GL_TEXTURE_GEN_S);
		glEnable(GL_TEXTURE_GEN_T);
	}
	
	//texture unit 0
	
	
	
	TheTerrain.drawDisplayList();
	

	glBindTexture(GL_TEXTURE_2D, tiTree.texID);

	int n;
	if (modes & MODE_TREES)
	{
		for(int n = 0; n<NUM_TREES; n++)	
		{
			TheTree[n].render(8.0f);
		}
		box.draw();

	}
	if (modes & MODE_FISH)
	{
		
		for( n = 0; n<NUM_FISH; n++)	
		{
			TheFish[n].render(1.0f);
		}
	}	
	if (modes & MODE_BOIDS)
	{
		for(n = 0; n<NUM_BOIDS; n++)	
		{
			TheBoid[n].render(1.0f);
		}
	}


/*	//TheFence[0].draw();
		Vec3F here, there;
		here.set(0,0,0);
		there.set(128*4.0f,0,128*4.0f);
	TheFence[0].newfence(here, there, 100, 10.0f, TheTerrain);
*/


	if (modes & MODE_WATER){
		glBindTexture(GL_TEXTURE_2D, texturelist[4]);
		if (modes & MODE_1STPERSON)
		{
			if(TheCamera.position.y < TheWater.level*4.0f)
			{
				TheWater.Draw3DTexturedSmoothRefracted(wateralpha, 0.1f, TRUE);		
			}
			else
			{
				TheWater.Draw3DTexturedSmoothRefracted(wateralpha, 0.1f, FALSE);
			}
		}
		else
		{
			TheWater.Draw3DTexturedSmoothRefracted(wateralpha, 0.1f, FALSE);
		}
	}
	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	
	if(modes & MODE_PARTICLES)
	{
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glDisable(GL_LIGHTING);
		emmit1.drawtex(40.0f, theta, phi);
		glEnable(GL_LIGHTING);
		glDisable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);
		
	}
	
	

	
	glDisable(GL_TEXTURE_2D);
	//THE GAME ======================================================================
	if(modes & MODE_GAME)
	{
		
		glColor3f(0.9f, 0.9f, 0.1f);
		TheProjectileWeapon.draw(25.0f);
		for(int n = 0; n<NUM_ENEMIES; n++)
		{
			TheEnemy[n].draw(1.0f);
			TheAgressor.draw(1.0f);
		}
		glColor3f(0.1f, 0.1f, 0.9f);
		
	}
	//THE GAME ========================================================================
	ThePlayer.draw(1.0f);
	
	TheCamera.draw(1.0f, 0.9f);


	glDisable(GL_LIGHTING);		
	drawlight(l0Dir, phi, theta, 5.0f, texturelist);
	glPopMatrix();

}
void display (void)
{
	static float theta= 30, phi= 30, trackX= 0, trackY= -0, depth= 825;
	static float l0colourDif[]= {1.0f, 1.0f, 1.0f, 1};
	static float l0colourSpec[]= {1.0f, 1.0f, 0.0f, 1};
	float sunscale = 5.0f;
//	int n;
	
	
	
	
	mouse_menu_input(gMouse, gVP, 64.0f);

	// Modify rotation and translation according to user input
	if ((gMouse.buttons & MB_LEFT) && (gMouse.buttons & MB_MID)){
		
		l0Dir[1] += gMouse.drag.y;
		gMouse.drag.x= 0;
		gMouse.drag.y= 0;
	}	
	
	if ((gMouse.buttons & MB_RIGHT) && (gMouse.buttons & MB_LEFT)){
		
		
		gFR.zoom += gMouse.drag.y/100.0f;
		
		gFR.left	= gFR.zoom * -0.5 * FR_WIDTH;
		gFR.right	= gFR.zoom *  0.5 * FR_WIDTH;
		gFR.bottom	= gFR.zoom * -0.5 * FR_HEIGHT;
		gFR.top		= gFR.zoom *  0.5 * FR_HEIGHT;
		printf("\n%f2.5f", gFR.zoom);
		
		
		gMouse.drag.x=0;
		gMouse.drag.y= 0;
	}	
	
	if (gMouse.buttons & MB_LEFT)
	{
		if (modes & MODE_1STPERSON)
		{
			TheCamera.RotateByMouse(gMouse, 256, 256, 0.1f);
		}
		else
		{
			theta+= gMouse.drag.x;
			phi-= gMouse.drag.y;
		}
		gMouse.drag.x= 0;
		gMouse.drag.y= 0;
	}
	
	if (gMouse.buttons & MB_RIGHT)
	{
		Vec3F temp;
		if (modes & MODE_1STPERSON)
		{
			if(keys['g']){
				TheCamera.SetHeight(gMouse.drag.y);
			}
			else
			{
				temp = TheCamera.position;
				
				TheCamera.Advance(gMouse.drag.y*0.25f);
				TheCamera.Strafe(gMouse.drag.x*0.25f);
				TheCamera.Ascend(TheTerrain.heightAtPoint(TheCamera.position.x, TheCamera.position.z)-TheCamera.position.y );
				TheCamera.Ascend(TheCamera.height);

				aabbPlayer.position = TheCamera.position;
				//aabbPlayer.halfSize.x = aabbPlayer.halfSize.y = aabbPlayer.halfSize.z = gMouse.drag.y;
				//printf("\nc[%f][%f][%f]",TheCamera.velocity.x,TheCamera.velocity.y,TheCamera.velocity.z);
				//printf("\tb[%f][%f][%f]",aabbPlayer.halfSize.x,aabbPlayer.halfSize.y,aabbPlayer.halfSize.z);
				if(aabbPlayer.aabbCollision(box))
					TheCamera.position = temp;
				if (modes & MODE_TREES)
				{
					aabb treebox;
					treebox.halfSize.x = treebox.halfSize.z = 0.5f;
					treebox.halfSize.y = 20.0f;
					for(int t = 0; t<NUM_TREES; t++)
					{
						treebox.position.x = TheTree[t].position.x;
						treebox.position.y = TheTree[t].position.y;
						treebox.position.z = TheTree[t].position.z;
						if(aabbPlayer.aabbCollision(treebox))
							TheCamera.position = temp;
					}
				}

				
			}
			
			emmit1.position.x = TheCamera.position.x;
			emmit1.position.y = TheCamera.position.y	+ 5;
			emmit1.position.z = TheCamera.position.z;
		}
		
		else
		{	
			depth+= gMouse.drag.y;	
		}
		gMouse.drag.x= 0;
		gMouse.drag.y= 0;
		
	}
	if (gMouse.buttons & MB_MID){
		if (modes & MODE_WATER){
			if((gMouse.pos.x < (128*3)) && (WIN_HEIGHT-gMouse.pos.y < (128*3)))
				TheWater.AddDrop(int(gMouse.pos.x/3), int((WIN_HEIGHT - gMouse.pos.y)/3));
		}else{
			
			l0Dir[0] += gMouse.drag.x;
			l0Dir[2] -= gMouse.drag.y;
			
			gMouse.drag.x= 0;
			gMouse.drag.y= 0;
		}
	}
	
	
	if (keys[32] == 1)
	{		
		Vec3F zero;
		zero.x = zero.y = zero.z = 0.0f;

		if(modes & MODE_WATER ) 
		{
			if(ThePlayer.position.y > TheWater.heightAtSmoothPoint(ThePlayer.position.x, ThePlayer.position.z) )
			{
			TheProjectileWeapon.fire(ThePlayer.position, zero, 3.0f);
			}
		}
		else
		{
			TheProjectileWeapon.fire(ThePlayer.position, zero, 3.0f);
		}

	}
	
	
	
	if (modes & MODE_WATER)
	{
		TheWater.Update();
		TheWater.smoothout();
	}
	if(modes & MODE_PARTICLES)
		emmit1.update(air);

	
	
	//GAME CODE
	if(modes & MODE_GAME)
	{
		game_loop();
	}//game
	else
	{		

		ThePlayer.move(keys, 0.5f);


	}
		
	if(modes & MODE_UPDATE_PLAYER)
	{
		Vec3F tv;
		tv=TheTerrain.DownHillVectorForPoint(ThePlayer.position.x, ThePlayer.position.z);
		ThePlayer.AdjustVelocity(tv.x, tv.y, tv.z);
		

		//if (modes & MODE_WATER)
		//{
		//	if(ThePlayer.position.y < TheWater.heightAtSmoothPoint(ThePlayer.position.x, ThePlayer.position.z))
		//	{
		//		ThePlayer.setHeight(TheWater.heightAtSmoothPoint(ThePlayer.position.x, ThePlayer.position.z));
		//		ThePlayer.Update(water);
		//	}
		//	else
		//	{
		ThePlayer.setHeight(TheTerrain.heightAtPoint(ThePlayer.position.x, ThePlayer.position.z));
		ThePlayer.Update(air);
		//	}
		//}
	}
	else
	{	Vec3F temp;
		temp = ThePlayer.position;

		ThePlayer.setHeight(TheTerrain.heightAtPoint(ThePlayer.position.x, ThePlayer.position.z));		
		ThePlayer.Update(air);
	if (modes & MODE_TREES)
		{
			aabbPlayer.position = ThePlayer.position;
			if(aabbPlayer.aabbCollision(box))
			ThePlayer.position = temp;
		}
	}

	if(upordown == 1)
		TheTerrain.AddBlobAt(ThePlayer.position.x/4+TERR_WIDTH*0.5, ThePlayer.position.z/4+TERR_DEPTH*0.5,rand()%10,rand()%3);				
	if(upordown == 2)
		TheTerrain.AddBlobAt(ThePlayer.position.x/4+TERR_WIDTH*0.5, ThePlayer.position.z/4+TERR_DEPTH*0.5,rand()%10,-1*rand()%3);				

	if(modes & MODE_TRACK)
		TheCamera.Lookat(ThePlayer.position.x, ThePlayer.position.y, ThePlayer.position.z);

	TheTerrain.Update(0.05f);

	int n;
	if (modes & MODE_TREES)
	{
		for( n = 0; n<NUM_TREES; n++)	
		{
			TheTree[n].update(TheTerrain, TheWater, (modes & MODE_WATER ));
		}
	}
	if (modes & MODE_FISH)
	{
		
		for( n = 0; n<NUM_FISH; n++)	
		{
			TheFish[n].think(50);
			TheFish[n].update(TheTerrain, TheWater);
		}
	}	
	if (modes & MODE_BOIDS)
	{
		for(n = 0; n<NUM_BOIDS; n++)	
		{
			TheBoid[n].centre(TheBoid, NUM_BOIDS, 0.1f);
			TheBoid[n].update(TheTerrain, TheWater);
		}
	}

//	RenderLightmap(256, WIN_WIDTH, WIN_HEIGHT, phi, theta, depth);

	//-----------------------------------------------------------------------------
	startFrame();
	// Rotate then translate the world
	glPushMatrix();
	
	
	if (modes & MODE_1STPERSON)
	{
		TheCamera.Set();
	}
	else
	{		
		glTranslatef(trackX, trackY, -depth);
		glRotatef(theta, 0,1,0);
		glRotatef(phi, 1,0,0);
	}	
	
	
	if (modes & MODE_ANAGLYPH)
	{
		renderAnaglyph(1.1f, theta, phi);
	}
	else
	{
		if (modes & MODE_CROSSEYED)
		{
			renderCrossEyed(1.1f, theta, phi);
		}
		else
		{			
			if((TheCamera.position.y < TheWater.level*4.0f) && (modes & MODE_WATER))
			{

				if (modes & MODE_1STPERSON)
				{
					renderSceneWobbly(theta, phi, 64, 4);
				}
				else
				{
					renderScene( theta,  phi);					
				}				
			}
			else
			{
				renderScene( theta,  phi);				
			}			
		}
	}

//	drawAxisInCorner(theta ,phi);
	
	
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, texturelist[1]);
	drawGui(64, 1.0f, gMouse, gVP, guiSize);
	
//	drawStats(ThePlayer);
	



	
	endFrame();
	
} // display


void renderSceneWobbly(float theta, float phi, float r, float magnitude)

{
		RenderToTexture(RENDEREDTEXTURESIZE,RENDEREDTEXTURESIZE, theta, phi, RenderedTexture);

	//#*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*#
			OrthoMode(gVP.origin.x, gVP.origin.y, gVP.size.x, gVP.size.y);
			glDisable(GL_LIGHTING);
			glDisable(GL_DEPTH_TEST);
			glPolygonMode( GL_FRONT, GL_FILL );	
			glColor4f(0.3f,0.8f,0.9f,0);
			glBindTexture(GL_TEXTURE_2D, RenderedTexture);
			glEnable(GL_TEXTURE_2D);

			 float tx = 1.0f/float(gVP.size.x);
			float ty = 1.0f/float(gVP.size.y);
			float tbvalX, tbvalY;
			tbvalX = 0;
			tbvalY = 0;
			//float r = 64;
			static float a = 0;			
			a+=0.08;		
			for(int y=0; y<gVP.size.y; y+=r)
			{
				glBegin(GL_TRIANGLE_STRIP);			
				for(int x=0; x<gVP.size.x; x+=r)
				{
				
					tbvalX = magnitude*sin((x*(y))+a);
					tbvalY = magnitude*cos((x*(y))+a);
			glTexCoord2f((x+((tbvalX)))*tx, (1.0f-(y+((tbvalY)))*ty));
			glVertex2f(x, y);

					tbvalX = magnitude*sin((x*(y+r))+a);
					tbvalY = magnitude*cos((x*(y+r))+a);
			glTexCoord2f((x+((tbvalX)))*tx, (1.0f-((y+r)+((tbvalY)))*ty));
			glVertex2f(x, y+r);

				}
				glEnd();
			}
			PerspectiveMode();	
			glEnable(GL_DEPTH_TEST);	
			glEnable(GL_LIGHTING);

	//#*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*#


}



void updateMouse (int x, int y)
{
	// Invert Y axis
	y= gVP.size.y - y;
	
	// Calculate motion vector
	gMouse.drag.x= x - gMouse.pos.x;
	gMouse.drag.y= y - gMouse.pos.y;
	
	// Store new position
	gMouse.pos.x= x;
	gMouse.pos.y= y;
} // updateMouse

void mouse (int button, int state, int x, int y)
{

	gMouse.lastbuttons = gMouse.buttons;

	switch (button)
	{
	case GLUT_LEFT_BUTTON :
		if (state == GLUT_DOWN)
		{
			gMouse.buttons|= MB_LEFT;
		}
		else
		{
			gMouse.buttons&= ~MB_LEFT;
		}
		break;
		
	case GLUT_MIDDLE_BUTTON :
		if (state == GLUT_DOWN)
		{
			gMouse.buttons|= MB_MID;
		}
		else
		{
			gMouse.buttons&= ~MB_MID;
		}
		break;
		
	case GLUT_RIGHT_BUTTON :
		if (state == GLUT_DOWN)
		{
			gMouse.buttons|= MB_RIGHT;
		}
		else
		{
			gMouse.buttons&= ~MB_RIGHT;
		}
		break;
	}
	updateMouse(x,y);
} // mouse

void motion (int x, int y)
{
	updateMouse(x,y);
} // motion

void passive (int x, int y)
{
	updateMouse(x,y);
} // passive

void keyboard (unsigned char key, int x, int y)
{
	int n;
	//	printf("\n%d",key);
	//printf("\nty:%2.2f", ThePlayer.position.y);
	float pm=1.0f;
	
	keys[key] = 1;
	switch (key)    {
	case 32	:	//space
		break;		
		
	//GAME - NEW LEVEL DIFFICULTY
	case 49	:	
		TheTerrain.Reset();
		for(n = 0; n<NUM_ENEMIES; n++)	
		{
			TheEnemy[n].reset();
			TheEnemy[n].position.x = (-TERR_WIDTH*2) + rand()%128*4;
			TheEnemy[n].position.z = (-TERR_DEPTH*2) + rand()%128*4;			
		}

		break;		
		
	case 50	:	
		TheTerrain.Reset();
		perlin128(perlin);
		TheTerrain.makeFromHeightMapI(perlin, 0.1f, 0);
		TheTerrain.normaliseHeight(10.0f, 1);
		for(n = 0; n<NUM_ENEMIES; n++)	
		{
			TheEnemy[n].reset();
			TheEnemy[n].position.x = (-TERR_WIDTH*2) + rand()%128*4;
			TheEnemy[n].position.z = (-TERR_DEPTH*2) + rand()%128*4;			
		}

		break;		

	case 51	:	
		TheTerrain.Reset();
		perlin128(perlin);
		TheTerrain.makeFromHeightMapI(perlin, 0.1f, 0);
		TheTerrain.normaliseHeight(10.0f, 1);
		LoadRawFile("textures/heightmap.raw", TERR_WIDTH*TERR_DEPTH, rawHeightMap);
		TheTerrain.makeFromHeightMap(rawHeightMap, 0.1f, 1);
		TheTerrain.normaliseHeight(10.0f, 1);
		for(n = 0; n<NUM_ENEMIES; n++)	
		{
			TheEnemy[n].reset();
			TheEnemy[n].position.x = (-TERR_WIDTH*2) + rand()%128*4;
			TheEnemy[n].position.z = (-TERR_DEPTH*2) + rand()%128*4;			
		}

		break;		


	case 52	:	

		wateralpha+=0.01f;
		break;		

	case 53	:	

		wateralpha-=0.01f;
		break;		




	case 'a' :
		TheTerrain.normaliseHeight(10.0f, 0);
		break;
	case 'A' :
		TheTerrain.normaliseHeight(10.0f, 1);
		break;
		
	case 'b' :
	case 'B' :
		TheTerrain.AddBlob(10,5);
		break;
		
	case 'c' :
	case 'C' :
		TheTerrain.CalcNormals();
		break;
		
	case 'd' :
	case 'D' :
		TheWater.AddDrop(1+rand()%126, 1+rand()%126);
		break;
		
	case 'e' :
	case 'E' :
		modes = modes ^ MODE_1STPERSON;
		break;
		
	case 'f' :
	case 'F' :
		TheTerrain.GenFaults(5,1);
		//TheTerrain.Set(0);
		break;
		
	case 'G' :
		gFR.zoom	= 1.0f;
		gFR.left	= gFR.zoom * -0.5 * FR_WIDTH;
		gFR.right	= gFR.zoom *  0.5 * FR_WIDTH;
		gFR.bottom	= gFR.zoom * -0.5 * FR_HEIGHT;
		gFR.top		= gFR.zoom *  0.5 * FR_HEIGHT;
		
		break;		
		
	case 'h' :
		LoadRawFile("textures/heightmap.raw", TERR_WIDTH*TERR_DEPTH, rawHeightMap);
		TheTerrain.makeFromHeightMap(rawHeightMap, 0.1f, 0);
		break;
	case 'H' :	
		TheTerrain.makeFromHeightMap(rawHeightMap, 0.1f, 1);
		break;
		
	case 'i':
	case 'I':
		ThePlayer.AdjustVelocity(0,0,-pm);
		break;
		
	case 'j':
	case 'J':
		ThePlayer.AdjustVelocity(-pm,0,0);
		break;
		
	case 'k':
	case 'K':
		ThePlayer.AdjustVelocity(0,0,+pm);
		break;
		
	case 'l':
	case 'L':
		ThePlayer.AdjustVelocity(+pm,0,0);
		break;
		
	case 'n' :
	case 'N' :			
		TheTerrain.AddNoise(3);
		break;
		
	case 'r' :
	case 'R' :
		TheTerrain.Reset();
		break;
		
		
	case 'o' :
	case 'O' :
		ThePlayer.reset();
		break;
		
	case 'p' :
		perlin128(perlin);
		TheTerrain.makeFromHeightMapI(perlin, 0.1f, 0);
		TheTerrain.normaliseHeight(10.0f, 1);
		TheTerrain.CalcNormals();
		break;
	case 'P' :
		perlin128(perlin);
		TheTerrain.makeFromHeightMapI(perlin, 0.1f, 1);
		TheTerrain.normaliseHeight(10.0f, 0);
		TheTerrain.CalcNormals();
		break;
		
	case 'q' :
	case 'Q' :
		Vec3F here, there;
		here.set(0,0,0);
		there.set(100,0,100);
		TheFence[0].newfence(here, there, 10, 5.0f, TheTerrain);
		break;
		
	case 's' :
	case 'S' :
		TheTerrain.Smooth();
		break;
		
	case 't' :
	case 'T' :
		TheWater.level++;
		break;
		
	case 'v' :
	case 'V' :	
		TheWater.level--;
		
		break;
		
		
	case 'w' :
	case 'W' :
		modes = modes ^ MODE_WATER;
		break;
		
	case 'x' :
	case 'X' :
		TheTerrain.texscale += 0.1f;
		break;
		
	case 'z' :
	case 'Z' :
		TheTerrain.texscale -= 0.1f;
		if(TheTerrain.texscale < 0) TheTerrain.texscale = 0;
		break;
		break;
	case KEY_ESC :
		exit(0);
		break;
		
    }
	updateMouse(x,y);
} // keyboard

void keyboardUp (unsigned char key, int x, int y)
{
	keys[key] = 0;
}

void SpecialKeys( int key, int x, int y)
{
	switch( key )
	{

	case GLUT_KEY_LEFT	:	keys[MY_LEFT]	= 1	;				break;
	case GLUT_KEY_RIGHT	:	keys[MY_RIGHT]	= 1	;				break;
	case GLUT_KEY_UP	:	keys[MY_UP]		= 1	;				break;
	case GLUT_KEY_DOWN	:	keys[MY_DOWN]	= 1	;				break;	
	
	case GLUT_KEY_F1	:	modes = modes ^ MODE_1STPERSON;		break;		
	case GLUT_KEY_F2	:	modes = modes ^ MODE_WIRE;			break;		
	case GLUT_KEY_F3	:	modes = modes ^ MODE_WATER;			break;		
	case GLUT_KEY_F4	:	modes = modes ^ MODE_ENV;			break;		
	case GLUT_KEY_F5	:	modes = modes ^ MODE_UPDATE_PLAYER;	break;		
	case GLUT_KEY_F6	:	modes = modes ^ MODE_TRACK;			break;		
	case GLUT_KEY_F7	:	modes = modes ^ MODE_CLOUDS;		break;		
	case GLUT_KEY_F8	:	modes = modes ^ MODE_ANAGLYPH;		break;		
	case GLUT_KEY_F9	:	modes = modes ^ MODE_PARTICLES;		break;		
	case GLUT_KEY_F10	:	modes = modes ^ MODE_GAME;			break;

	case GLUT_KEY_F11	:	glutFullScreen( );				
							break;		
	case GLUT_KEY_F12	:	glutReshapeWindow(WIN_WIDTH, WIN_HEIGHT);
							glutPositionWindow  ( 100,100 ); 
							break;

	case GLUT_KEY_PAGE_UP:		upordown = 1;		break;		
	case GLUT_KEY_PAGE_DOWN:	upordown = 2;		break;


		
		
	}
}

void SpecialKeysUp( int key, int x, int y)
{
	switch( key )
	{
	case GLUT_KEY_LEFT	:		keys[MY_LEFT]	= 0	;	break;
	case GLUT_KEY_RIGHT	:		keys[MY_RIGHT]	= 0	;	break;
	case GLUT_KEY_UP	:		keys[MY_UP]		= 0	;	break;
	case GLUT_KEY_DOWN	:		keys[MY_DOWN]	= 0	;	break;
	case GLUT_KEY_PAGE_UP:		upordown		= 0;	break;		
	case GLUT_KEY_PAGE_DOWN:	upordown		= 0;	break;

	}
}

void reshape (int x, int y)
{/*
	if ((x*0.75)<y){
		gVP.size.x= x;
		gVP.size.y= x*0.75;
		gVP.origin.x = 0;
		gVP.origin.y = y/2 - gVP.size.y/2;
	}
	else{
		gVP.size.x= y*1.333333;
		gVP.size.y= y;
		gVP.origin.x = x/2 - gVP.size.x/2;
		gVP.origin.y = 0;
	}*/
	
	gFR.left=	x * (-0.5 * FR_WIDTH / WIN_WIDTH);
	gFR.right=	x * (0.5 * FR_WIDTH / WIN_WIDTH);
	
	  gFR.bottom=	y * (-0.5 * FR_HEIGHT / WIN_HEIGHT);
	  gFR.top=	y * (0.5 * FR_HEIGHT / WIN_HEIGHT);
	  
		// Set viewport to size of window
		gVP.size.x= x;
	gVP.size.y= y;
} // reshape

int main (int argc, char *argv[])
{
	// Set up basic GLUT stuff
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_STENCIL);
	glutInitWindowSize(WIN_WIDTH, WIN_HEIGHT);
	glutInitWindowPosition(16, 16);
	glutCreateWindow("Terrain Demo");
	
	// Initialise program data
	init();
	
    // Inform GLUT of this programs IO callback functions
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	glutPassiveMotionFunc(passive);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutKeyboardUpFunc(keyboardUp);
	glutSpecialFunc(SpecialKeys);
	glutSpecialUpFunc(SpecialKeysUp);
	
    // Start the glut window processing loop (never exits)
	glutMainLoop();
	
	return(0);
} // main


void game_loop(){
int n;
		
		ThePlayer.moveInCircle(keys, 0.01f, 250);
		TheProjectileWeapon.update(TheTerrain);	

		TheAgressor.base.moveInCircle(0.01f,128);
		if(TheTerrain.isOnTerrain(TheAgressor.base.position.x, TheAgressor.base.position.z)){
			TheAgressor.base.setHeight(TheTerrain.heightAtPoint(TheAgressor.base.position.x, TheAgressor.base.position.z));
		}

		TheAgressor.shoot(ThePlayer.position);
		TheAgressor.gun.update(TheTerrain);

		// MOVE ENEMIES
		for(n = 0; n<NUM_ENEMIES; n++)
		{	
			//is enemy active?		
			if((TheEnemy[n].active == 1))
			{	
				//MOVE ENEMY
				if(TheEnemy[n].energy > 0)
				{
					//TheEnemy[n].moveInCircle(0.003f*(-10+n), -64+(8*n));
					TheEnemy[n].moveTowards(ThePlayer.position, 0.1*(n+1));
					//TheEnemy[n].moveRandom(1.0f);
					
					if(TheTerrain.isOnTerrain(TheEnemy[n].position.x, TheEnemy[n].position.z)){
						TheEnemy[n].setHeight(TheTerrain.heightAtPoint(TheEnemy[n].position.x, TheEnemy[n].position.z));
					}
					TheEnemy[n].Update(air);			
				}//move
				
				for(int i = 0; i<NUMPROJECTILES; i++)//vs bullets
				{
					// check enamy vs bullet collision
					if( (TheProjectileWeapon.bullet[i].collideSphere(TheEnemy[n].position, TheEnemy[n].radius) ) )
					{
						TheEnemy[n].energy-=10;
						TheProjectileWeapon.bullet[i].reset();
						
						//destroy if necessary
						if(TheEnemy[n].energy < 1)
						{
							TheTerrain.AddBlobAt(0.25*TheEnemy[n].position.x+(TERR_WIDTH*0.5), 0.25*TheEnemy[n].position.z+(TERR_WIDTH*0.5), 10,-1);
						}//destroy
					}//bullet				
				}//bullets
				
				if(collisionSphereSphere(TheEnemy[n].position, TheEnemy[n].radius, ThePlayer.position, 5.0f) )
					// colide vs player
				{
					ThePlayer.energy--;
					if(ThePlayer.energy < 1)
					{
						TheTerrain.AddBlobAt(0.25*ThePlayer.position.x+(TERR_WIDTH*0.5), 0.25*ThePlayer.position.z+(TERR_WIDTH*0.5), 10,-1);
					}//destroy
					
				}//p collide
			}//active
		}//enemies

}

void renderCrossEyed(float seperation, float theta, float phi)
{
	
	RenderToTexture(RENDEREDTEXTURESIZE,RENDEREDTEXTURESIZE, theta, phi, RenderedTexture);

	if (modes & MODE_1STPERSON)
	{
		TheCamera.Strafe(-seperation);
		TheCamera.Set();
		TheCamera.Strafe(seperation);
	}


	RenderToTexture(RENDEREDTEXTURESIZE,RENDEREDTEXTURESIZE, theta, phi, RenderedTexture2);

	//#*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*#
			OrthoMode(0, 0, WIN_WIDTH, WIN_HEIGHT);
			glDisable(GL_LIGHTING);
			glDisable(GL_DEPTH_TEST);
			glPolygonMode( GL_FRONT, GL_FILL );	

			glEnable(GL_BLEND);			
			glBindTexture(GL_TEXTURE_2D, RenderedTexture);
			glEnable(GL_TEXTURE_2D);

	// it hurts
	// crosseyed 3d
	
			glColor4f(1.0f,1.0f,1.0f,1.0f);
				glBegin(GL_QUADS);	
					
				glTexCoord2f(0,0);
				glVertex2f(0, 0);
				
				glTexCoord2f(0,-1);
				glVertex2f(0, gVP.size.y/2);
				
				glTexCoord2f(1,-1);
				glVertex2f(gVP.size.x/2, gVP.size.y/2);
				
				glTexCoord2f(1,0);
				glVertex2f(gVP.size.x/2, 0);
				glEnd();

			glBindTexture(GL_TEXTURE_2D, RenderedTexture2);

				glBegin(GL_QUADS);	
					
				glTexCoord2f(0,0);
				glVertex2f(gVP.size.x/2, 0);
				
				glTexCoord2f(0,-1);
				glVertex2f(gVP.size.x/2, gVP.size.y/2);
				
				glTexCoord2f(1,-1);
				glVertex2f(gVP.size.x, gVP.size.y/2);
				
				glTexCoord2f(1,0);
				glVertex2f(gVP.size.x, 0);
				glEnd();

			glDisable(GL_BLEND);
			PerspectiveMode();	
			glEnable(GL_DEPTH_TEST);	
			glEnable(GL_LIGHTING);
}
void renderAnaglyph(float seperation, float theta, float phi)
{
	
	RenderToTexture(RENDEREDTEXTURESIZE,RENDEREDTEXTURESIZE, theta, phi, RenderedTexture);

	if (modes & MODE_1STPERSON)
	{
		TheCamera.Strafe(-seperation);
		TheCamera.Set();
		TheCamera.Strafe(seperation);
	}

	//sketchy anaglyph

	RenderToTexture(RENDEREDTEXTURESIZE,RENDEREDTEXTURESIZE, theta, phi, RenderedTexture2);

	//#*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*##*#*#*#**#*#*#*#*#
			OrthoMode(0, 0, WIN_WIDTH, WIN_HEIGHT);
			glDisable(GL_LIGHTING);
			glDisable(GL_DEPTH_TEST);
			glPolygonMode( GL_FRONT, GL_FILL );	

			glEnable(GL_BLEND);			
			glBindTexture(GL_TEXTURE_2D, RenderedTexture);
			glEnable(GL_TEXTURE_2D);

			glColor4f(1.0f,0.0f,0.0f,0.5f);
				glBegin(GL_QUADS);	
					
				glTexCoord2f(0,0);
				glVertex2f(0, 0);
				
				glTexCoord2f(0,-1);
				glVertex2f(0, WIN_HEIGHT);
				
				glTexCoord2f(1,-1);
				glVertex2f(WIN_WIDTH, WIN_HEIGHT);
				
				glTexCoord2f(1,0);
				glVertex2f(WIN_WIDTH, 0);
				glEnd();

			glBindTexture(GL_TEXTURE_2D, RenderedTexture2);

			glColor4f(0.0f,1.0f, 0.988f,0.5f);
				glBegin(GL_QUADS);	
					
				glTexCoord2f(0,0);
				glVertex2f(0, 0);
				
				glTexCoord2f(0,-1);
				glVertex2f(0, WIN_HEIGHT);
				
				glTexCoord2f(1,-1);
				glVertex2f(WIN_WIDTH, WIN_HEIGHT);
				
				glTexCoord2f(1,0);
				glVertex2f(WIN_WIDTH, 0);
				glEnd();


			glDisable(GL_BLEND);
			PerspectiveMode();	
			glEnable(GL_DEPTH_TEST);	
			glEnable(GL_LIGHTING);
}



void mouse_menu_input(Mouse &tmouse, Viewport &vp, float scale)
{
	int mx, my, button;//within gui
	guiSize.y = guiSize.x;
	if(	(tmouse.pos.x < (256*guiSize.x)+vp.origin.x)	&&
		(vp.size.y - tmouse.pos.y) < 320)
		
	{
		if(guiSize.x < 1.0f)
			guiSize.x += guiSize.x/2;

		if(guiSize.x > 1.0f)
			guiSize.x = 1.0f;

	mx = (tmouse.pos.x-guiPos.x)/scale;
	my = (vp.size.y - (tmouse.pos.y)-guiPos.y)/scale;
	button = mx+4*my;

if (tmouse.buttons & MB_LEFT)
{
	switch(button)
	{
	case 0:
		TheTerrain.Reset();
		break;

	case 1:
		TheTerrain.AddNoise(3);
		break;

	case 2:
		TheTerrain.AddBlob(10,5);
		break;

	case 3:		
		TheTerrain.GenFaults(5,1);
		break;

	case 4:
		TheTerrain.Smooth();
		break;

	case 5:
		TheTerrain.normaliseHeight(10.0f, 1);
		break;

	case 6:		
		perlin128(perlin);
		TheTerrain.makeFromHeightMapI(perlin, 0.1f, 0);
		TheTerrain.normaliseHeight(10.0f, 1);
		break;

	case 7:
		mx = (tmouse.pos.x-guiPos.x-scale*3)/(scale*0.5f);
		my = (vp.size.y - (tmouse.pos.y)-guiPos.y - scale)/(scale*0.5f);
		switch(mx+2*my)
		{
		case 0:
			TheTerrain.texscale += 0.05f;
			TheTerrain.thinking = TRUE;
			break;
			
		case 1:
			TheWater.level ++;
			break;
			
		case 2:
			TheTerrain.texscale -= 0.05f;
			TheTerrain.thinking = TRUE;
			break;
			
		case 3:		
			TheWater.level --;
			break;
		}		

		break;

	case 8:		
		LoadRawFile("textures/heightmap.raw", TERR_WIDTH*TERR_DEPTH, rawHeightMap);
		TheTerrain.makeFromHeightMap(rawHeightMap, 0.1f, 0);
		break;

	case 9:
		modes = modes ^ MODE_UPDATE_PLAYER;
		break;

	case 10:
		modes = modes ^ MODE_1STPERSON;
		break;

	case 11:
		modes = modes ^ MODE_TRACK;
		break;

	case 12:
		modes = modes ^ MODE_WIRE;
		break;

	case 13:
		modes = modes ^ MODE_WATER;
		break;

	case 14:
		modes = modes ^ MODE_ENV;
		break;

	case 15:
		if( style3d++ > 2)
			style3d = 0;
		if(style3d == 0)
		{			
			modes = modes ^ MODE_CROSSEYED;
		}
		if(style3d == 1)	
		{			
			modes = modes ^ MODE_ANAGLYPH;
		}		
		if(style3d == 2)
		{			
			modes = modes ^ MODE_ANAGLYPH;
			modes = modes ^ MODE_CROSSEYED;
		}			
		
		break;

	case 16:
		modes = modes ^ MODE_TREES;
		break;

	case 17:
		modes = modes ^ MODE_FISH;
		break;

	case 18:
		modes = modes ^ MODE_BOIDS;
		break;

	case 19:
		thelp();
		break;


	}
}

		gMouse.drag.x= 0;
		gMouse.drag.y= 0;

	}
	else
	{
		if(guiSize.x > 0.05f)
			guiSize.x -= guiSize.x/2;

		if(guiSize.x < 0.05f)
			guiSize.x = 0.05f;


	}
	//	guiSize.x = 0.05f;

}