#include "Header/basicDraw.h"

void thelp()
{
	printf("\nChris McLaughlin \t 0102502 \t Terrain Demo");
	printf("\n-------------------------------------------------------------------------------");
	printf("\nmouse + left drag       : camera rotation");
	printf("\nmouse + right drag      : camera position");
	printf("\nmouse + middle drag     : light position       [+left drag : light height] ");
	printf("\nmouse + left+right drag : camera zoom");
	printf("\n-------------------------------------------------------------------------------");
	printf("\nHover over menu in top left for action controls");
	printf("\n");
	printf("\n-------------------------------------------------------------------------------");
	printf("\nF1 : 1st/3rd Person Camera     F2: Wireframe           F3: Water ");
	printf("\nF4 : Environment Map           F5: Refresh Player      F6: Camera Track Player");
	printf("\nF7 : Unassigned                F8: Stereo Anaglyph     F9: Particles on[ugly]");
	printf("\nF10: Game [ left/right keys move, space fires | 1/2/3 restart]");
	printf("\n");
	printf("\n-------------------------------------------------------------------------------");
	printf("\nterrain control:");
	printf("\np: perlin noise generation");
	printf("\nh: load heightmap\t\tT: add heightmap");
	printf("\nn: add noise");
	printf("\nf: fault line generation");
	printf("\nb: add blob");
	printf("\ns: smooth");	
	printf("\na: normalise colouring\t\tA: normalise height");
	printf("\n");

}

void GlutOutputText3D(GLfloat x, GLfloat y, GLfloat z, float scale, char *text)
{
    char *p;
    
    glPushMatrix();
    glTranslatef(x, y, 0);
    glScalef(scale,scale,scale);
    for (p = text; *p; p++)
        glutStrokeCharacter(GLUT_STROKE_ROMAN, *p);
    glPopMatrix();
}

void drawGui(float scale, float alpha, Mouse &tmouse, Viewport &vp, Vec2I &size)
{
int x, y, mx, my;

			OrthoMode(0, 0, WIN_WIDTH, WIN_HEIGHT);
			glDisable(GL_LIGHTING);
			glDisable(GL_DEPTH_TEST);
			//glPolygonMode( GL_FRONT, GL_LINE );			
			//glEnable(GL_BLEND);			
			glColor4f(1,1,1,alpha);


			mx = (tmouse.pos.x - vp.origin.x  )/scale;
			my = (vp.size.y - (tmouse.pos.y))/scale;
//			printf("\nm %d, %d", mx, my);

			glBegin(GL_QUADS);			
			for (x = 0; x<4; x++){	
				for (y = 0; y<5; y++){	

					if( ( x == mx ) && ( y == my ) )
						glColor4f(1.0f,1.0f,1.0f,alpha);
					else
						glColor4f(0.65f,0.65f,0.65f,alpha);


					glTexCoord2f(x*0.25f, -1*y*0.125f);
					glVertex2f(x*scale*size.x,			y*scale*size.y);

					glTexCoord2f(x*0.25f, -1*(y+1)*0.125f);
					glVertex2f(x*scale*size.x,			y*scale*size.y+scale*size.y);

					glTexCoord2f((x+1)*0.25f, -1*(y+1)*0.125f);
					glVertex2f(x*scale*size.x+scale*size.x,	y*scale*size.y+scale*size.y);

					glTexCoord2f((x+1)*0.25f, -1*y*0.125f);
					glVertex2f(x*scale*size.x+scale*size.x,	y*scale*size.y);


				}
			}
			glEnd();

			glPolygonMode( GL_FRONT, GL_FILL );			

			PerspectiveMode();			
			//glDisable(GL_BLEND);
			glEnable(GL_DEPTH_TEST);	
			glEnable(GL_LIGHTING);


}

void drawStats(player &thisplayer)
{
	OrthoMode(0, 0, WIN_WIDTH, WIN_HEIGHT);
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glPolygonMode( GL_FRONT, GL_FILL );	
	
	glDisable(GL_BLEND);
	glLineWidth(10.0f);
	glColor3f(1.0f,thisplayer.energy*0.01f,0.0f);
	glBegin(GL_LINES);				
		glVertex2f(10, WIN_HEIGHT-10);		
		glVertex2f(10, WIN_HEIGHT-10-thisplayer.energy);	
	glEnd();
	
	glLineWidth(1.0f);
	glColor3f(0.0f,0.0f,0.0f);
		glBegin(GL_LINES);				
		glVertex2f(5,	WIN_HEIGHT-10);		
		glVertex2f(5,	WIN_HEIGHT-10-thisplayer.energy);	
		glVertex2f(15,	WIN_HEIGHT-10);		
		glVertex2f(15,	WIN_HEIGHT-10-thisplayer.energy);
		
		glVertex2f(5,	WIN_HEIGHT-10);		
		glVertex2f(15,	WIN_HEIGHT-10);	
		glVertex2f(5,	WIN_HEIGHT-10-thisplayer.energy);		
		glVertex2f(15,	WIN_HEIGHT-10-thisplayer.energy);

	glEnd();

	

	glEnable(GL_DEPTH_TEST);	
	glEnable(GL_LIGHTING);
	PerspectiveMode();		
	
	
}

void drawlight(float l0Dir[], float phi, float theta, float sunscale, GLuint texture[]){
	//light stuff-------------------------------------------------------------------
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);
	glLineWidth(3);
	glBegin(GL_LINES);
	glColor4f(0.95f, 0.95f, 0.0f, 0.9f);
		glVertex3f(l0Dir[0],0,l0Dir[2]);
		glColor4f(0.95f, 0.95f, 0.0f, 0.0f);
		glVertex3f(l0Dir[0], l0Dir[1]/4, l0Dir[2]);
	glEnd();

	glLineWidth(1);

    glTranslatef(l0Dir[0], l0Dir[1], l0Dir[2]);

	float lc = l0Dir[1]*0.01f;
	if (lc > 1) lc = 1;
	glClearColor(0.8f*lc, 0.8f*lc, 1.0f*lc, 1.0f);	//  background

	//draw sun-------------------------------------------------------------------------
	glColor4f(1.0f, 1.0f, 1.0f, 0.8f);
	glPushMatrix();
		glRotatef(-phi, 1,0,0);
		glRotatef(-theta, 0,1,0);

		glEnable(GL_TEXTURE_2D);						// Enable Texture Mapping ( NEW )
		glBindTexture(GL_TEXTURE_2D, texture[0]);				// Select Our Texture
		glBegin(GL_QUADS);
			glTexCoord2f(0.0f,0.0f);	glVertex3f(-sunscale, +sunscale, 0);
			glTexCoord2f(1.0f,0.0f);	glVertex3f(-sunscale, -sunscale, 0);
			glTexCoord2f(1.0f,1.0f);	glVertex3f(+sunscale, -sunscale, 0);
			glTexCoord2f(0.0f,1.0f);	glVertex3f(+sunscale, +sunscale, 0);
		glEnd();
	glPopMatrix();

	glDisable(GL_TEXTURE_2D);

	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
}



void drawAxes(float scale, float linewidth, float alpha){
	
	if (alpha < 1.0f) glEnable(GL_BLEND);
	glLineWidth(linewidth);

	glBegin(GL_LINES);
	glColor4f(1.0f,0,0, alpha);
	glVertex3f(0,0,0);
	glVertex3f(scale,0,0);
	
	glColor4f(0,1.0f,0, alpha);
	glVertex3f(0,0,0);
	glVertex3f(0,scale,0);
	
	glColor4f(0,0,1.0f, alpha);
	glVertex3f(0,0,0);
	glVertex3f(0,0,scale);
	glEnd();
		
	glLineWidth(1.0f);
	glDisable(GL_BLEND);

}

void drawAxisInCorner(float theta, float phi){
	glPushMatrix();
		glTranslatef(-4, -4, -20);
		glRotatef(theta, 0,1,0);
		glRotatef(phi, 1,0,0);

		glDisable(GL_DEPTH_TEST);
		glDisable(GL_LIGHTING);

		drawAxes(1.0f, 2.0f, 1.0f);

		glEnable(GL_LIGHTING);
		glEnable(GL_DEPTH_TEST);
	glPopMatrix();

}