#include "Header/boids.h"


boid::boid()
{
	position.set(0.0f,0.0f,0.0f);

}


void boid::init(float px, float py, float pz)
{
	position.set(px, py, pz);
	heading.RandDir(1);

	colour.r = randF32()*1.0f;
	colour.g = randF32()*1.0f;
	colour.b = randF32()*1.0f;

	speed				=	0.1f;
	perceptionRadius	=	50.0f;
	size				=	1.0f;	

}

void boid::centre(boid list[],int numboids, float strength)
{

	Vec3F	distout, avgpos, avgdir, awaydir;
	int		numVisibleToMe = 0, numCloseToMe = 0;
	avgpos.set(0,0,0);
	avgdir.set(0,0,0);
	awaydir.set(0,0,0);
	


	for(int i = 0; i<numboids; i++)
	{
		distout = position - list[i].position;
	//	if( distout.LengthNoRoot() < perceptionRadius)
	//	{
			avgpos += list[i].position;
			avgdir += list[i].heading;
			numVisibleToMe++;
			if(distout.LengthNoRoot() < 50.0f)
			{
				awaydir -= ( position - list[i].position);
				numCloseToMe++;
			}
	//	}
	}
	
	avgpos	/= numVisibleToMe;
	avgdir	/= numVisibleToMe;
	awaydir /= numCloseToMe;

	heading.set(0,0,0);

	//heading += (( avgdir - heading) *strength);
	//heading += (( avgpos - position) *strength);
	heading += (( position - awaydir) *strength);


	if(heading.LengthNoRoot() > speed)
	{
		heading.Normalize();
		heading *= speed;

	}
		


}


void boid::update(terrain &ThisTerrain, water2d &ThisWater)
{

	position += heading;

}


void boid::render(float scale)
{		

	glPushMatrix();
	glTranslatef(position.x, position.y+(scale*size*0.5f), position.z);
	glColor4f(colour.r, colour.g, colour.b, 1.0f);
	glutSolidCube(scale*size);
	glPopMatrix();


}
