#include "Header/emmiter.h"
#include <windows.h>
#include "Header/defines.h"

emmiter::emmiter(){		//build emmiter default values

	position.x	= 0,
	position.y	= 0,
	position.z	= 0,

	direction.x = 1,
	direction.y = 1,
	direction.z = 1,

	area.x		= 0,
	area.y		= 0,
	area.z		= 0,

	sprayangle	= 0,
	velocity	= 1, 
	mass		= 1, 
	elasticity	= 1;
	scale		= 0.5f;
	texture		= 1;

	colour.r	= 1.0f;
	colour.g	= 1.0f;
	colour.b	= 1.0f;
	colour.a	= 1.0f;

	visibility	= 1;

}
void emmiter::reset(){
	for(int i = 0; i<NUMPARTS; i++){
		myparts[i].alive = 1;
		emmit(i);
	}
}
void emmiter::emmit(int me){

	myparts[me].position.x = position.x + ( (float)((rand()/32767.0)-0.5f) * area.x );
	myparts[me].position.y = position.y + ( (float)((rand()/32767.0)-0.5f) * area.y );
	myparts[me].position.z = position.z + ( (float)((rand()/32767.0)-0.5f) * area.z );
	
	myparts[me].oldpos.x = myparts[me].position.x;
	myparts[me].oldpos.y = myparts[me].position.y;
	myparts[me].oldpos.z = myparts[me].position.z;

	myparts[me].velocity.x = ( (float)(rand()/32767.0)-0.5f) * velocity * direction.x;	
	myparts[me].velocity.y = ( (float)(rand()/32767.0)-0.5f) * velocity * direction.y;	
	myparts[me].velocity.z = ( (float)(rand()/32767.0)-0.5f) * velocity * direction.z;	

	myparts[me].mass = mass;
	myparts[me].elasticity = elasticity;
	myparts[me].scale = scale;

	myparts[me].texture = texture;

	myparts[me].birthage = (float)(rand()%200);
	myparts[me].age = myparts[me].birthage;
	myparts[me].alive = 1;

	myparts[me].colour.r = colour.r;
	myparts[me].colour.g = colour.g;
	myparts[me].colour.b = colour.b;
}

void emmiter::update(environment thisworld){
	int i;
	for(i = 0; i<NUMPARTS; i++){
		if(myparts[i].alive == 1)
			myparts[i].update(thisworld, 0.0f, 1.0f);
		else
			emmit(i);
	}

}

void emmiter::draw(float scale, float theta, float phi){
	int i;
	for(i = 0; i<NUMPARTS; i++){
		if(myparts[i].alive == 1)
			myparts[i].drawFlatQuad(theta, phi);
	}
}

void emmiter::drawtex(float scale, float theta, float phi){
	int i;
	for(i = 0; i<NUMPARTS; i++){
		if(myparts[i].alive == 1)
			myparts[i].drawTexturedQuad(theta, phi);
	}
}

void emmiter_setup(emmiter *emmit1){

	emmit1->position.x	= 0,
	emmit1->position.y	= 0,
	emmit1->position.z	= 0,

	emmit1->direction.x = 1,
	emmit1->direction.y = 5,
	emmit1->direction.z = 1,

	emmit1->area.x		= 0,
	emmit1->area.y		= 0,
	emmit1->area.z		= 0,

	emmit1->sprayangle	= 0,
	emmit1->velocity	= 1.5f, 
	emmit1->mass		= 5.0f, 
	emmit1->elasticity	= 0.01f;
	emmit1->scale		= 2.0f;
	emmit1->texture		= 3;

	emmit1->colour.r	= 1.0f;
	emmit1->colour.g	= 1.0f;
	emmit1->colour.b	= 0.0f;
	emmit1->colour.a	= 0.5f;

	emmit1->visibility	= 1;

}
/*
void keysEmmiter(emmiter *thisemmiter, char keys[256], int &submode, Col3F &subcolour){


	if(keys['\\']){
		submode = SUB_LOCK;
		subcolour.g = subcolour.b = 1.0f;
		keys['\\'] = 0;
	}
	if(keys['z']){
		submode = SUB_MOVE;
		subcolour.g = subcolour.b = 1.0f;
		keys['z'] = 0;
	}	
	if(keys['x']){
		submode = SUB_ROTATE;
		subcolour.g = subcolour.b = 0.1f;
		keys['x'] = 0;
	}
	if(keys['c']){
		submode = SUB_SIZE;
		subcolour.g = subcolour.b = 1.0f;
		keys['c'] = 0;
	}
	if(keys['v']){
		submode = SUB_COLOUR;
		subcolour.g = subcolour.b = 1.0f;
		keys['v'] = 0;
	}
	if(keys['b']){
		submode = SUB_MASS;
		subcolour.g = subcolour.b = 1.0f;
		keys['b'] = 0;
	}	
	if(keys['n']){
		submode = SUB_GRAVITY;
		subcolour.g = subcolour.b = 0.1f;
		keys['n'] = 0;
	}
	if(keys['m']){
		submode = SUB_TEXTURE;
		subcolour.g = subcolour.b = 1.0f;
		keys['m'] = 0;
	}	
	if(keys[',']){
		submode = SUB_VELOCITY;
		subcolour.g = subcolour.b = 1.0f;
		keys[','] = 0;
	}
	if(keys['.']){
		submode = SUB_SCALE;
		subcolour.g = subcolour.b = 1.0f;
		keys['.'] = 0;
	}
	if(keys['/']){
		submode = SUB_ELAST;
		subcolour.g = subcolour.b = 1.0f;
		keys['/'] = 0;
	}


}


void mouseEmmiter(emmiter *thisemmiter,  Mouse *gMouse, int &submode){


	if (gMouse->buttons & MB_RIGHT){
		switch (submode){
			case SUB_MOVE:
				thisemmiter->position.y -= gMouse->drag.y/10.0f;
				gMouse->drag.y= 0;	
			break;
			case SUB_SIZE:
				thisemmiter->area.y -= gMouse->drag.y/10.0f;
				gMouse->drag.y= 0;	
			break;			
			case SUB_COLOUR:
				thisemmiter->colour.b -= gMouse->drag.y/100.0f;
				if(thisemmiter->colour.b < 0) thisemmiter->colour.b = 0;
				printf("\ncolour: (%2.2f, %2.2f, %2.2f)", thisemmiter->colour.r, thisemmiter->colour.g, thisemmiter->colour.b);
				gMouse->drag.x= 0;
				gMouse->drag.y= 0;	
			break;
			case SUB_MASS:
				thisemmiter->mass += gMouse->drag.y/100.0f;
				printf("\nmass: %2.2f", thisemmiter->mass);
				gMouse->drag.y= 0;	
			break;	
			case SUB_TEXTURE:
				thisemmiter->tselect -= gMouse->drag.y;
				thisemmiter->texture = thisemmiter->tselect / 10;
				if(thisemmiter->tselect < 20) thisemmiter->tselect = 20;
				if(thisemmiter->tselect > NUMTEXTURES*10) thisemmiter->tselect = NUMTEXTURES*10;
				printf("\ntselect: %2.2f   :: texture %d", thisemmiter->tselect, thisemmiter->texture);
				gMouse->drag.y= 0;	
			break;
			case SUB_VELOCITY:
				thisemmiter->velocity -= gMouse->drag.y/100.0f;
				if(thisemmiter->velocity < 0) thisemmiter->velocity = 0;
				printf("\nvelocity: %2.2f", thisemmiter->velocity);
				gMouse->drag.y= 0;	
			break;	
			case SUB_SCALE:
				thisemmiter->scale -= gMouse->drag.y/100.0f;
				if(thisemmiter->scale < 0) thisemmiter->scale = 0;
				printf("\nscale: %2.2f", thisemmiter->scale);
				gMouse->drag.y= 0;	
			break;
			case SUB_ELAST:
				thisemmiter->elasticity -= gMouse->drag.y/100.0f;
				if(thisemmiter->elasticity < 0) thisemmiter->elasticity = 0;
				printf("\nelasticity: %2.2f", thisemmiter->elasticity);
				gMouse->drag.y= 0;	
			break;

		}
	
	}

	if (!(gMouse->buttons & MB_LEFT)){
	switch (submode){
		case SUB_MOVE:
			thisemmiter->position.x += gMouse->drag.x/10.0f;
			thisemmiter->position.z += gMouse->drag.y/10.0f;
			gMouse->drag.x= 0;
			gMouse->drag.y= 0;		
			break;
		case SUB_SIZE:
			thisemmiter->area.x += gMouse->drag.x/10.0f;
			thisemmiter->area.z += gMouse->drag.y/10.0f;
			gMouse->drag.x= 0;
			gMouse->drag.y= 0;		
			break;		
		case SUB_COLOUR:
				thisemmiter->colour.r += gMouse->drag.x/100.0f;
				thisemmiter->colour.g += gMouse->drag.y/100.0f;
				if(thisemmiter->colour.r < 0) thisemmiter->colour.r = 0;
				if(thisemmiter->colour.g < 0) thisemmiter->colour.g = 0;
				if(thisemmiter->colour.r > 1) thisemmiter->colour.r = 1;
				if(thisemmiter->colour.g > 1) thisemmiter->colour.g = 1;
				printf("\ncolour: (%2.2f, %2.2f, %2.2f)", thisemmiter->colour.r, thisemmiter->colour.g, thisemmiter->colour.b);
				gMouse->drag.x= 0;	
				gMouse->drag.y= 0;	
			break;


		}
	}
}

*/