/*
	Copyright A N Houston, University of Abertay Dundee, Sept 2001.

	$Id$

	Portions of this code obtained from Numerical Recipies in C
*/

#include "Header/fastRand.h"


/*** COMPILATION DIRECTIVES ***/


/*** CONSTANTS ***/

#define FLOAT_BITS			(32)
#define FLOAT_MANTISSA_BITS	(23)
#define FLOAT_EXP_SIGN_BITS	(FLOAT_BITS-FLOAT_MANTISSA_BITS)


#define RAND_NORM_SCALE	((float)1.0/(1<<FLOAT_MANTISSA_BITS))

/*** TYPES ***/


/*** MACROS ***/


/*** GLOBALS ***/

static unsigned int seed=1;


/*** FUNCTIONS ***/

void randSeed (unsigned int s)
{
	if (s != 0)
	{
		seed= s;
	}
} // randSeed

// Fast modulo 2^32 generator from Numerical Recipies in C
unsigned int randU32 (void)
{
	seed= seed * 1664525 + 1013904223;

	return(seed);
} // randU32

float randF32 (void)
{
	return(randU32() >> FLOAT_EXP_SIGN_BITS)*RAND_NORM_SCALE;
} // randF32
