#include "Header/fire.h"

fire::fire(){
	int x, y;
		
	init_colours(0, 255, 0,0,255 , 250,255,0);
	for (y=0; y<FIRESIZE_Y; y++){
		for (x=0; x<FIRESIZE_X; x++){	
			field[x][y] = 255-y;
			buffer[x][y] = 0;
		}
	}


}
void fire::setpoint(int x, int y){

	field[y][x] = 255;
	field[y+1][x] = 255;
	field[y][x+1] = 255;
	field[y+1][x+1] = 255;
}



void fire::addspark(){
int x,y;
x = rand()%FIRESIZE_X;
y = rand()%FIRESIZE_Y;
//x=254;
	
	field[x][y] = 255;
	field[x][y+1] = 255;
	field[x][y+2] = 255;
	field[x][y+3] = 255;
	field[x][y-1] = 255;
	field[x][y-2] = 255;

}

void fire::update(float speed, float strength){
int x,y;

//inside
	for (y=1; y<FIRESIZE_Y-1; y++){
		for (x=1; x<FIRESIZE_X-1; x++){	
			buffer[x][y] = ( field[x-1][y] + field[x+1][y] + field[x][y-1] + field[x][y+1] ) / (4.0f * strength);
		}
	}

	
	//scroll up
	for (y=0; y<FIRESIZE_Y; y++){
		for (x=0; x<FIRESIZE_X; x++){	
			field[int(x-speed)][y] = buffer[x][y];
		}
	}

	
	//corners = ( Noise(x-1, y-1)+Noise(x+1, y-1)+Noise(x-1, y+1)+Noise(x+1, y+1) ) / 16
    //sides   = ( Noise(x-1, y)  +Noise(x+1, y)  +Noise(x, y-1)  +Noise(x, y+1) ) /  8
    //center  =  Noise(x, y) / 4
}

void fire::draw2D(float scale, float transparency){
int x, y, col;

			OrthoMode(0, 0, WIN_WIDTH, WIN_HEIGHT);
			glDisable(GL_LIGHTING);
			glDisable(GL_DEPTH_TEST);			
			//glEnable(GL_BLEND);
			
			glBegin(GL_QUADS);			
			for (y = 0; y<FIRESIZE_Y; y++){
				for (x = 0; x<FIRESIZE_X; x++){
					col = int(field[y][x]);
					glColor4f(clut[col].r, clut[col].g, clut[col].b, transparency);
					glVertex2f(x*scale,			y*scale);
					glVertex2f(x*scale+scale,	y*scale);
					glVertex2f(x*scale+scale,	y*scale+scale);
					glVertex2f(x*scale,			y*scale+scale);
				}
			}
			glEnd();

			PerspectiveMode();			
			//glDisable(GL_BLEND);
			glEnable(GL_DEPTH_TEST);	
			glEnable(GL_LIGHTING);

}



void fire::init_colours(int p1, int p2, int r1, int g1, int b1, int r2, int g2, int b2){
	int dp, dr, dg, db, gr, gg, gb;
	
	dp=p2-p1;
			 dr=r2-r1;
			 dg=g2-g1;
			 db=b2-b1;
			 gr=dr/dp;
			 gg=dg/dp;
			 gb=db/dp;
			 
			 for(int lp=p1; lp < p2-1; lp++){
				 clut[lp].r = float(r1/256.0);
				 clut[lp].g = float(g1/256.0);
				 clut[lp].b = float(b1/256.0);
				 r1=r1+gr;
				 g1=g1+gg;
				 b1=b1+gb;
			 }
			 
			 clut[lp].r = float(r1/256.0);
			 clut[lp].g = float(g1/256.0);
			 clut[lp].b = float(b1/256.0);			
}



void fire::buildRandomPalette(){
	
	int palette_size=256;
	int mid1=palette_size-70;
	int theend=palette_size;
	int r1, r2, g1, g2, b1, b2;
	
	r1=rand()%256;	g1=rand()%256;	b1=rand()%256;
	r2=rand()%256;	g2=rand()%256;	b2=rand()%256;
	init_colours(mid1,theend,r2,g2,b2,r1,g1,b1);
	
	r1=r2;	g1=g2;	b1=b2;
	r2=rand()%256;	g2=rand()%256;	b2=rand()%256;
	init_colours(0,mid1,r2,g2,b2,r1,g1,b1);
}