#include "Header/fish.h"


fish::fish()
{
	position.set(0.0f,0.0f,0.0f);

}

void fish::init(float px, float py, float pz)
{
	position.set(px, py, pz);
	heading.RandDir(1);
	nextheading.set(0,0,0);

	colour.r = randF32()*1.0f;
	colour.g = randF32()*1.0f;
	colour.b = randF32()*1.0f;

	speed	=	0.1f;
	radius	=	5.0f;
	size	=	1.0f;	

}


void fish::random(float dx, float dz, water2d &ThisWater, terrain &ThisTerrain)
{
	position.randomise(dx, ThisWater.level*4.0f, dz);
}

void fish::think(int neuralSpeed)
//neural speed - how quick can the fish think about changing
{
	if( ( (int)randF32()*neuralSpeed ) == 0.0)
	{
		nextheading.RandDir(1);
	
	}
}

void fish::update(terrain &ThisTerrain, water2d &ThisWater)
{
	heading += nextheading*0.2f;
	heading.Normalize();

	position += heading * speed;

	
	if( ( position.y > ThisWater.level*4.0f) && (nextheading.y>0.0f))
	{
		(nextheading.y *= -1);
		(position.y = ThisWater.level*4.0f);

		
		if(ThisWater.level*4.0f < ThisTerrain.heightAtPoint(position.x, position.z))
			position.randomise(TERR_WIDTH, ThisWater.level*4.0f, TERR_DEPTH);


	}

	if(position.y < ThisTerrain.heightAtPoint(position.x, position.z))
	{
		if(ThisWater.level*4.0f < ThisTerrain.heightAtPoint(position.x, position.z))
			position.randomise(TERR_WIDTH, ThisWater.level*4.0f, TERR_DEPTH);

		if(heading.y<0.0f)
		{
			position.y = ThisTerrain.heightAtPoint(position.x, position.z);
			(heading.y *= -1);
		}

	}


}

void fish::render(float scale)
{		

	glPushMatrix();
	glTranslatef(position.x, position.y+(scale*size*0.5f), position.z);
	glColor4f(colour.r, colour.g, colour.b, 1.0f);
	glutSolidCube(scale*size);
	glPopMatrix();


}
