
#include "myfuncs.h"
#include "defines.h"



void CalculateFrameRate()
{
	//no credit for me, this is digibens from gametutorials.com


	static float framesPerSecond    = 0.0f;							// This will store our fps
    static float lastTime			= 0.0f;							// This will hold the time from the last frame
	//static char strFrameRate[50] = {0};								// We will store the string here for the window title

    float currentTime = GetTickCount() * 0.001f;				

	// Increase the frame counter
    ++framesPerSecond;

    if( currentTime - lastTime > 1.0f )
    {
		// Here we set the lastTime to the currentTime.  This will be used as the starting point for the next second.
		// This is because GetTickCount() counts up, so we need to create a delta that subtract the current time from.
	    lastTime = currentTime;
		
		// Copy the frames per second into a string to display in the window title bar
		//sprintf(strFrameRate, "Current Frames Per Second: %d", int(framesPerSecond));

		// Set the window title bar to our string
		//SetWindowText(g_hWnd, strFrameRate);
printf("\n fps: %d",int(framesPerSecond));
		// Reset the frames per second
        framesPerSecond = 0;
    }
}


void drawLight(GLfloat LightPosition[][4]){
	glBegin(GL_LINES);			
		glVertex3f(0, 0, 0);
		glVertex3f(LightPosition[0][0], 0, 0);

		glVertex3f(LightPosition[0][0], 0, 0);
		glVertex3f(LightPosition[0][0], 0, LightPosition[0][2]);

		glVertex3f(LightPosition[0][0], 0, LightPosition[0][2]);
		glVertex3f(LightPosition[0][0], LightPosition[0][1], LightPosition[0][2]);
	glEnd();
		
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition[0]);			// Position The Light
	
	glPushMatrix();
		glTranslatef(LightPosition[0][0], LightPosition[0][1], LightPosition[0][2]);
		glutWireSphere(0.2,8,4);
	glPopMatrix();


}

void drawBorder(Viewport &gVP){

		glColor3f(0.5f,0.5f,0.5f);
		glLineWidth(5);
		glBegin(GL_LINES);
			glVertex2f(0,0);
			glVertex2f(0,gVP.size.y);

			glVertex2f(0,gVP.size.y);
			glVertex2f(gVP.size.x,gVP.size.y);

			glVertex2f(gVP.size.x-1,gVP.size.y);
			glVertex2f(gVP.size.x-1,0);
			
			glVertex2f(gVP.size.x,1);
			glVertex2f(0,1);
		glEnd();

	glLineWidth(1);
}

void cubefield(float cubesize, float spacing, int fieldsize){
int tx,ty,tz;

	for (tx = -fieldsize; tx< fieldsize; tx++){
		for (ty = -fieldsize; ty< fieldsize; ty++){
			for (tz = -fieldsize; tz< fieldsize; tz++){
			glPushMatrix();
				glTranslatef(tx*spacing, ty*spacing, tz*spacing);
				glutSolidCube(cubesize);
			glPopMatrix();
			}
		}
	}
}

void referencegrid(int size){
int mx;

	glBegin(GL_LINES);			// reference grid 
		for(mx=-size;mx<size;mx++){
			glVertex3f(-size,0,mx);	
			glVertex3f(size,0,mx);
			glVertex3f(mx,0,size);	
			glVertex3f(mx,0,-size);
		}
	glEnd();
}

void referencegridPoly(int size){
int mx, mz;

	glBegin(GL_QUADS);			// reference grid 
		for(mz=-size;mz<size;mz++){
			for(mx=-size;mx<size;mx++){
				glNormal3f( 0.0f, 1.0f, 0.0f);
				glVertex3f(mx,		0,	mz);	
				glVertex3f(mx+1.0f,	0,	mz);
				glVertex3f(mx+1.0f,	0,	mz+1.0f);	
				glVertex3f(mx,		0,	mz+1.0f);
			}
		}
	glEnd();
}

void gelplate(float xsize, float zsize, Col4F gel, Col4F outline, int borderwidth){

	glColor4f(gel.r, gel.g, gel.b, gel.a);
	glBegin(GL_QUADS);
			glVertex3f(xsize, 0, zsize);	
			glVertex3f(xsize, 0, -zsize);
			glVertex3f(-xsize, 0, -zsize);	
			glVertex3f(-xsize, 0, zsize);
	glEnd();

	glDisable(GL_BLEND);	

	glColor4f(outline.r, outline.g, outline.b, outline.a);	
	glLineWidth(borderwidth);
	glBegin(GL_LINES);
			glVertex3f(xsize, 0, zsize);	
			glVertex3f(xsize, 0, -zsize);

			glVertex3f(xsize, 0, -zsize);
			glVertex3f(-xsize, 0, -zsize);	

			glVertex3f(-xsize, 0, -zsize);	
			glVertex3f(-xsize, 0, zsize);

			glVertex3f(-xsize, 0, zsize);
			glVertex3f(xsize, 0, zsize);
	glEnd();
	glLineWidth(1);
	glEnable(GL_BLEND);	


}

