#include "Header/perlin.h"


void PerlinSmooth(int A[][128], int out[][128]){
int x, y;
float corner, edge, centre;

	for (y = 1; y<127; y++){
		for (x = 1; x<127; x++){				
				corner =	(	A[x-1][y-1]+	A[x+1][y-1]+	A[x-1][y+1]+	A[x+1][y+1] ) / 16.0f;
				edge =		float( A[x-1][y]  +	A[x+1][y] +		A[x][y-1]  +	A[x][y+1] ) /  8.0f;
				centre =	A[x][y] / 4.0f;				
				out[x][y] = int(corner + edge + centre);
		}		
	}

		// Process left and right edges
	y= 128-1;
	while (y-- > 1)
	{
		edge=float(	A[0][y-1]	+	A[0][y]	+	A[0][y+1]   + 
					A[1][y-1]	+	A[1][y]	+	A[1][y+1]);

		out[0][y]= int(edge * 1.0 / 6);

		edge=float(	A[128-1][y-1]	+	A[128-1][y]	+	A[128-1][y+1]   + 
					A[128-2][y-1]	+	A[128-2][y]	+	A[128-2][y+1]);

		out[128-1][y]= int(edge * 1.0 / 6);
	}

		// Process far and near edges
	x= 128-1;
	while (x-- > 1)
	{
		edge=float(		A[x-1][0]	+	A[x][0]	+	A[x+1][0]   + 
				A[x-1][1]	+	A[x][1]	+	A[x+1][1]);

		out[x][0]= int(edge * 1.0 / 6);

		edge=float(		A[x-1][128-1]	+	A[x][128-1]	+	A[x+1][128-1]   +
				A[x-1][128-2]	+	A[x][128-2]	+	A[x+1][128-2]);

		out[x][128-1]= int(edge * 1.0 / 6);
	}


	// Process corners
	corner= float(	A[0][0]	+	A[1][0] +
					A[0][1]	+	A[1][1]);

	out[0][0]= int( corner * 1.0 / 4);

	corner= float(A[128-1][0]	+	A[128-2][0] +
			A[128-1][1]	+	A[128-2][1]);

	out[128-1][0]= int( corner * 1.0 / 4);

	corner= float(A[128-1][128-1]	+	A[128-2][128-1] +
			A[128-1][128-2]	+	A[128-2][128-2]);

	out[128-1][128-1]= int( corner * 1.0 / 4);

	corner= float(A[0][128-1]	+	A[0][128-1] +
			A[1][128-2]	+	A[1][128-2]);

	out[0][128-1]= int( corner * 1.0 / 4);


}



void perlin128(int array[][128]){
	int A[128][128];
	int B[128][128];
	int C[128][128];
	int D[128][128];
	int E[128][128];

	int x, y, u,v, r;
	
	//srand(seed);


	for (y = 0; y<16; y++){
		for (x = 0; x<16; x++){
			r = rand()%255;
			for(u = 0; u<8; u++){
				for(v = 0; v<8; v++){
					B[(x*8)+u][(y*8)+v] = r;
				}
			}
		}
	}
	
	for (y = 0; y<32; y++){
		for (x = 0; x<32; x++){
			r = rand()%128;
			for(u = 0; u<4; u++){
				for(v = 0; v<4; v++){
				C[x*4+u][y*4+v] = r;
			//	C[x*4+u][y*4+v] = 0;
				}
			}
		}
	}
	for (y = 0; y<64; y++){
		for (x = 0; x<64; x++){
			r = rand()%64;
			for(u = 0; u<2; u++){
				for(v = 0; v<2; v++){
				D[x*2+u][y*2+v] = r;
			//	D[x*2+u][y*2+v] = 0;
				}
			}
		}
	}

	for (y = 0; y<128; y++){
		for (x = 0; x<128; x++){
				E[x][y] = rand()%32;
			//	E[x][y] = 0;
		}
	}
// lots of smoothing passes
	PerlinSmooth(B,A);
	PerlinSmooth(A,B);	
	PerlinSmooth(B,A);
	PerlinSmooth(A,B);	
	PerlinSmooth(B,A);
	PerlinSmooth(A,B);	
	
	PerlinSmooth(C,B);
	PerlinSmooth(D,C);
	PerlinSmooth(E,D);

	for (y = 0; y<128; y++){
		for (x = 0; x<128; x++){
		array[x][y] = A[x][y] + int(B[x][y] / 2) + int(C[x][y] / 4) + int(D[x][y] / 8);
	//	array[x][y] = array[x][y] % 255;
		}	
	}
}



void draw128(int array[][128], float scale){

int x, y;
float drawarray[128][128], max, min, diff;

// set vals to between 1 - 0
	max = min = array[0][0];
	for(y=0; y<128; y++){
		for(x=0; x<128; x++){
			if(	array[x][y] > max) max = array[x][y];
			if(	array[x][y] < min) min = array[x][y];
		}
	}
	diff = max-min;

	for(y=0; y<128; y++){
		for(x=0; x<128; x++){
			drawarray[x][y] = float((array[x][y]-min)/diff);
		}
	}


			OrthoMode(0, 0, WIN_WIDTH, WIN_HEIGHT);
			glDisable(GL_LIGHTING);
			glDisable(GL_DEPTH_TEST);			
			//glEnable(GL_BLEND);
			
			glBegin(GL_QUADS);			
			for (y = 0; y<128; y++){
				for (x = 0; x<128; x++){
					glColor3f(drawarray[x][y], drawarray[x][y], drawarray[x][y]);
					glVertex2f(x*scale,			y*scale);
					glVertex2f(x*scale,			y*scale+scale);
					glVertex2f(x*scale+scale,	y*scale+scale);
					glVertex2f(x*scale+scale,	y*scale);
				}
			}
			glEnd();

			PerspectiveMode();			
			//glDisable(GL_BLEND);
			glEnable(GL_DEPTH_TEST);	
			glEnable(GL_LIGHTING);


}


void MakeClouds(int array[][128]){
int x, y;

	for (y = 0; y<128; y++)
		for (x = 0; x<128; x++)
			array[x][y] = CloudynessFromExp(array[x][y], 64, 0.99);
}


int CloudynessFromExp(int v, int CloudCover, float CloudSharpness){
int c;
int CloudDensity;

	  c = v - CloudCover;
      if (c < 0) c=0;
 
      CloudDensity = 255 - (pow(CloudSharpness,c) * 255);

      return CloudDensity;
}