#include "Header/skybox.h"

skybox::skybox(){
	texturestart = 6;
}

void skybox::draw(float scale, GLuint tex[]){

	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);


	glBindTexture(GL_TEXTURE_2D, tex[texturestart]);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE); 
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glColor3f(1.0f,1.0f,1.0f);
	glBegin(GL_QUADS);
		//FRONT
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-scale, -scale, scale);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-scale,  scale, scale);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( scale,  scale, scale);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( scale, -scale, scale);	// Bottom Left Of The Texture and Quad
		glEnd();

		//BACK
		glBindTexture(GL_TEXTURE_2D, tex[texturestart+1]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE); 
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

		glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-scale, -scale,  -scale);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( scale, -scale,  -scale);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( scale,  scale,  -scale);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-scale,  scale,  -scale);	// Top Left Of The Texture and Quad
		glEnd();

		//RIGHT
		glBindTexture(GL_TEXTURE_2D, tex[texturestart+2]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE); 
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(scale, -scale, -scale);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(scale, -scale,  scale);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(scale,  scale,  scale);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(scale,  scale, -scale);	// Top Left Of The Texture and Quad
		glEnd();

		//LEFT
		glBindTexture(GL_TEXTURE_2D, tex[texturestart+3]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE); 
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-scale, -scale, -scale);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-scale,  scale, -scale);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-scale,  scale,  scale);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-scale, -scale,  scale);	// Bottom Left Of The Texture and Quad
		glEnd();


		//TOP
		glBindTexture(GL_TEXTURE_2D, tex[texturestart+4]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE); 
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-scale, scale, -scale);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( scale, scale, -scale);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( scale, scale,  scale);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-scale, scale,  scale);	// Bottom Right Of The Texture and Quad
		glEnd();

		//BOTTOM
		glBindTexture(GL_TEXTURE_2D, tex[texturestart+5]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE); 
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-scale,  -scale, -scale);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-scale,  -scale,  scale);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( scale,  -scale,  scale);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( scale,  -scale, -scale);	// Top Right Of The Texture and Quad
		glEnd();



	

	glEnable(GL_LIGHTING);

}