#include "Header/tree.h"


tree::tree()
{
	position.set(0.0f,0.0f,0.0f);

}

void tree::init(float px, float pz, terrain &ThisTerrain)
{
	position.set(px, 0.0f, pz);
	position.y = ThisTerrain.heightAtPoint(position.x, position.z);

}


void tree::random(float dx, float dz, terrain &ThisTerrain)
{
	position.randomise(dx, 0.0f, dz);
	position.y = ThisTerrain.heightAtPoint(position.x, position.z);

}


void tree::update(terrain &ThisTerrain, water2d &ThisWater, int wateron)
{
	if(wateron)
	{
		if(position.y < ThisWater.level*4.0f)
			random(TERR_WIDTH*2, TERR_DEPTH*2, ThisTerrain);
	}

	position.y = ThisTerrain.heightAtPoint(position.x, position.z);
}

void tree::render(float scale)
{		
	glPolygonMode( GL_BACK, GL_FILL );					// Back Face Is Made Of Lines
	//glDisable(GL_CULL_FACE);

	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_DEPTH_TEST);
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glBegin(GL_QUADS);
	{
			glNormal3f(0,0,1);
			glTexCoord2f(0.0f, 0.0f);
			glVertex3f(position.x-scale,	position.y+2*scale,	position.z);
			glTexCoord2f(0.0f, -1.0f);
			glVertex3f(position.x-scale,	position.y,			position.z);
			glTexCoord2f(1.0f, -1.0f);
			glVertex3f(position.x+scale,	position.y,			position.z);
			glTexCoord2f(1.0f, 0.0f);
			glVertex3f(position.x+scale,	position.y+2*scale,	position.z);

			glNormal3f(1,0,0);
			glTexCoord2f(0.0f, 0.0f);
			glVertex3f(position.x,	position.y+2*scale,	position.z-scale);
			glTexCoord2f(0.0f, -1.0f);
			glVertex3f(position.x,	position.y,			position.z-scale);
			glTexCoord2f(1.0f, -1.0f);
			glVertex3f(position.x,	position.y,			position.z+scale);
			glTexCoord2f(1.0f, 0.0f);
			glVertex3f(position.x,	position.y+2*scale,	position.z+scale);

			glNormal3f(0,0,-1);
			glTexCoord2f(1.0f, 0.0f);
			glVertex3f(position.x+scale,	position.y+2*scale,	position.z);
			glTexCoord2f(1.0f, -1.0f);
			glVertex3f(position.x+scale,	position.y,			position.z);
			glTexCoord2f(0.0f, -1.0f);
			glVertex3f(position.x-scale,	position.y,			position.z);
			glTexCoord2f(0.0f, 0.0f);
			glVertex3f(position.x-scale,	position.y+2*scale,	position.z);

			glNormal3f(-1,0,0);
			glTexCoord2f(1.0f, 0.0f);
			glVertex3f(position.x,	position.y+2*scale,	position.z+scale);
			glTexCoord2f(0.0f, 0.0f);
			glVertex3f(position.x,	position.y+2*scale,	position.z-scale);
			glTexCoord2f(0.0f, -1.0f);
			glVertex3f(position.x,	position.y,			position.z-scale);
			glTexCoord2f(1.0f, -1.0f);
			glVertex3f(position.x,	position.y,			position.z+scale);
	}
	glEnd();

	//glEnable(GL_CULL_FACE);
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);

}



/*

-s,2s,		s,2s
 |----------|
 |			|
 |			|
 |			|
 |			|
 |	  0.0	|
 |----------|
-s,0		s,0






  */