#include "Header/Weapons.h"

projectile::projectile(){

	reset();


}

void projectile::reset(){
	position	= 0.0f;
	velocity	= 0.0f;
	radius	= 0.1f;
	active = 0;

}


void projectile::launch(Vec3F &from, Vec3F &to, float speed){

	position = from;
	velocity = to - from;
	velocity.Normalize();
	velocity *= speed;
	active = 1;

}

void projectile::update(){

	position+=velocity;

}


void projectile::setHeight(float h){

	position.y = h;

}

int projectile::collideSphere(Vec3F target, float radius)
{
	if(	active == 1 )
		return collisionSphereSphere(position, radius, target, radius);
	
	return 0;

}

void projectile::draw(float scale){

	if(	active == 1 )
	{
	glPushMatrix();
		glTranslatef(position.x, position.y+(scale*0.5), position.z);
		//glutSolidSphere(scale*radius, 3, 2);
		glutSolidCube(scale*radius);
	glPopMatrix();
	}

}


//==========================================================================
// projectile weapon
//==========================================================================


projectileWeapon::projectileWeapon()
{

	reset();

}

void projectileWeapon::reset()
{

	for (int i = 0; i < NUMPROJECTILES; i++)
		bullet[i].reset();
	round = 0;

}

void projectileWeapon::fire(Vec3F &from, Vec3F &to, float speed)
{

	bullet[round++].launch(from, to, speed);

	if ( round == NUMPROJECTILES )
		round = 0;


}



void projectileWeapon::update(terrain &thisterrain)
{
Vec3F zero;
zero.x = zero.y = zero.z = 0.0f;
	for (int i = 0; i < NUMPROJECTILES; i++){
		if(thisterrain.isOnTerrain(bullet[i].position.x, bullet[i].position.z)){
			bullet[i].setHeight(thisterrain.heightAtPoint(bullet[i].position.x, bullet[i].position.z));
		}	
		bullet[i].update();

		

	}
}

void projectileWeapon::draw(float scale)
{

	for (int i = 0; i < NUMPROJECTILES; i++)
		bullet[i].draw(scale);

}
